ad_page_contract {
    This is the central interface for managing a user's subscriptions.

    @author Anukul Kapoor <akk@arsdigita.com>
    @creation-date 2001-03-27
    @cvs-id $Id: subscriptions.tcl,v 1.6 2005/03/01 00:01:14 jeffd Exp $
} {
} -properties {
    title:onevalue
    context:onevalue
    forum_subs:multirow
    category_subs:multirow
    thread_subs:multirow
}

auth::require_login

set user_id [ad_conn user_id]

set title "Manage Subscriptions"
set context [list $title]

# three sorts of subscriptions:
#  forums

db_multirow forum_subs get_forum_subs {
    select bfs.forum_id, short_name as name
      from bboard_forum_subscribers bfs, bboard_forums bf
      where bfs.forum_id = bf.forum_id
            and bfs.subscriber_id = :user_id
      order by forum_id asc
}

#  categories
db_multirow category_subs get_category_subs {
    select bcs.category_id, short_name as name, forum_id
      from bboard_category_subscribers bcs, bboard_categories bc
      where bcs.category_id = bc.category_id
            and bcs.subscriber_id = :user_id
      order by category_id asc
}


#  threads

db_multirow thread_subs get_thread_subs {
    select thread_id, title as name, forum_id
      from bboard_thread_subscribers bts, bboard_messages_all bma
      where bts.thread_id = bma.message_id
            and bts.subscriber_id = :user_id
      order by thread_id asc
}