# /packages/ticket-tracker/wf-templates/ticket-info.tcl

ad_page_contract {
    Return info about an object.

    @author Dirk Gomez (sharenet@dirkgomez.de)
    @author Timo Hentschel (timo@arsdigita.com)
    @creation-date 2002-02-27
    @cvs-id $Id: object-info.tcl,v 1.1 2003/07/02 12:19:45 peterm Exp $
}    

# task is one of the datasources specified in the <include> tag in /packages/acs-workflow/www/task.adp
set object_id $task(object_id)

if { ![db_0or1row get_object_info "
    select o.object_type_id, o.one_line_description as object_name,
        decode(o.public_p,'t',1,0) as public_p, 
        o.original_author_id, u.first_names || ' ' || u.last_name as original_author_name,
        u.email as original_author_email
    from sn_objects o, users u
    where o.object_id = :object_id
        and u.user_id = o.original_author_id
"] } {
    # Error: The object does not exist.

    if { $print_errors_p } {
        ad_return_exception_page 404 "Entry does not exist." "
        The entry with id $object_id  does not exist.
        We never really delete object IDs from the database so this is quite 
        unusual.  Unless you tried to hack the URL manually this might be a bug 
        in our software."
    }
    return 0
}

set pretty_type [km_static object_type_pretty_name $object_type_id]
set pretty_type_plural [km_static object_type_pretty_plural $object_type_id]
set stripped_name [sn_striphtml $object_name]
set object_name [km_get_object_name $object_id]
