ad_page_contract {
    /www/library/add-sharenet-ref.tcl

    Called after the user has selected an existing or created a new
    object. Appends a reference to this object to the question
    associated with the current path.
    
    @cvs-id $Id: add-sharenet-ref.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    path_id:notnull
    object_id:notnull,integer
}
csrf::authenticate

if ![path_valid_p $path_id] {
    ad_return_error "Invalid Path" \
	"The current path ID is invalid. Perhaps you used your browser's Back button
	 and tried to press the <cite>Link</cite> button a second time?"
    return
}

set user_id [auth::require_login]


# Determine to which object we are going to add the href,
# and if the current user is allowed to do this.

set values [get_path_values -action_only_p 0 $path_id]
set original_object_id [value_from_tuples $values object_id]
set sub_object_id [value_from_tuples $values sub_object_id]

if ![km_check_object_id -check_edit_p 1 $original_object_id] { return }


# OK, let's insert it.

if [empty_string_p $sub_object_id] {
    set question_id [value_from_tuples $values question_id]
    set row_id $original_object_id
} else {
    set question_id [value_from_tuples $values subquestion_id]
    set row_id $sub_object_id
}

km_append_object_content -html_p "t" $row_id $question_id \
    "<a href=\"/o/$object_id\">[km_get_object_name $object_id]</a>"

km_check_public_status_after_edit $row_id

# All done, back to the path's origin.

ad_returnredirect [get_path_return_url $path_id]
