ad_page_contract {
    /www/library/add-web-ref-2.tcl

    Verify Web or email reference, and append it to the column given as
    part of the path.
    
    @cvs-id $Id: add-web-ref-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    path_id:notnull,integer
    url
    url_title
}
csrf::authenticate

if ![path_valid_p $path_id] {
    ad_return_error "Invalid Path" \
	"The current path ID is invalid. Perhaps you used your browser's Back button
	 and tried to enter another Web/email reference?"
    return
}

set user_id [auth::require_login]

# Determine to which object we are going to add the href,
# and if the current user is allowed to do this.

set values [get_path_values -action_only_p 0 $path_id]
set object_id [value_from_tuples $values object_id]
set sub_object_id [value_from_tuples $values sub_object_id]
   

# Check the user input.

if ![km_check_object_id -check_edit_p 1 $object_id] { return }

set examples "
    <ul>
     <li>A valid URL would be something like <b>http://photo.net/philg/</b>,
     <li>A valid E-mail address would be something like: <b>philg@mit.edu</b>.
    </ul>"

set exception_count 0
set exception_text ""

if { ![empty_string_p $url] && ![util_url_valid_p $url] && ![util_email_valid_p $url] } {
    # There is a URL or email, but it doesn't match our REGEXP.

    incr exception_count
    append exception_text "<li>The text you entered: <b>$url</b> looks
    neither like an URL nor like an E-mail address.
    $examples
    "
}

if [empty_string_p $url] {
   incr exception_count
   append exception_text "<li>Please enter an URL or an E-mail address.
   $examples"
}

if { $exception_count > 0 } {
    ad_return_complaint $exception_count $exception_text
    return
}

if [empty_string_p $url_title] { set url_title $url }
if [util_email_valid_p $url] { set url "mailto:$url" }


# OK, let's append it.

if [empty_string_p $sub_object_id] {
    set question_id [value_from_tuples $values question_id]
} else {
    set question_id [value_from_tuples $values subquestion_id]
    set object_id $sub_object_id
}

km_append_object_content -html_p "t" $object_id $question_id "<a href=\"$url\">$url_title</a>"

km_check_public_status_after_edit $object_id

# All done, back to the path's origin.

ad_returnredirect [get_path_return_url $path_id]


