ad_page_contract {
    /packages/library/www/admin/add-description.tcl

    @author Dirk Gomez (dirk@arsdigita.com)
    @cvs-id $Id: add-description.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $
} {
    question_id
    object_type_id
    abstract_data_type
    short_p
} -properties {
}
csrf::authenticate

db_transaction {
    if {$short_p} {
        db_dml add_description_2 {delete from sn_types_map_short_name
        where object_type_id=:object_type_id}

        db_dml add_description_4 {insert into sn_types_map_short_name 
        values (:object_type_id, :question_id, 1)}

        db_dml add_description_16 {update sn_objects set one_line_description = null where object_type_id=:object_type_id}
    } else {
	db_dml add_description_14 {update sn_object_types set long_description = :question_id where object_type_id=:object_type_id}

	db_dml add_description_16 {update sn_objects set overview = null where object_type_id=:object_type_id}
    }
}

km_static -reset $object_type_id

if { [lsearch {text file integer} $abstract_data_type] != -1 } {

    if { $short_p } {
	db_dml add_description_30 "
	update sn_objects obj
	set one_line_description = (select dbms_lob.substr(content,0,3999) from sn_content 
				    where question_id=:question_id 
					and object_id=obj.object_id)
	where object_type_id=:object_type_id"

	db_dml add_description_35 {
	update acs_objects_description aodesc
	set shortname = (select  dbms_lob.substr(content,0,3999) from sn_content 
	where question_id=:question_id
	and aodesc.object_id=object_id)
	where aodesc.object_id in 
	    (select object_id from sn_objects obj where obj.object_type_id=:object_type_id)}

    } else {
	db_dml add_description_40 "
	update sn_objects obj
	set overview = (select dbms_lob.substr(content,0,3999) from sn_content 
			where question_id=:question_id 
			    and object_id=obj.object_id),
	    overview_html_p = (select html_p from sn_content 
			       where question_id=:question_id 
			           and object_id=obj.object_id)
	where object_type_id=:object_type_id"
    }

    set descriptions [db_list_of_lists add_description_50 "
	select c.object_id, c.content, c.html_p
	from sn_content c, sn_objects obj
	where c.question_id=:question_id
	    and c.object_id = obj.object_id
	    and obj.object_type_id = :object_type_id"]

    foreach description $descriptions {
	set object_id [fst $description]
	set QQcontent [util_trim_string_with_hrefs [snd $description] 2000]
	set html_p [thd $description]

	if { $short_p } {
	    db_dml add_description_60 "
		update sn_objects 
		set one_line_description = :QQcontent
		where object_id=:object_id"
	} else {
	    db_dml add_description_70 "
		update sn_objects 
		set overview = :QQcontent, overview_html_p = :html_p
		where object_id=:object_id"
	}
    }

} elseif { $abstract_data_type == "date" } {

    set sql_add_description_80 "
	select c.object_id, content
	from sn_content c, sn_objects obj
	where question_id=:question_id
	    and c.object_id = obj.object_id
	    and obj.object_type_id = :object_type_id"

    db_foreach add_description_80 $sql_add_description_80 {
	if { $short_p } {
	    db_dml add_description_90 "
		update sn_objects 
		set one_line_description = '[util_AnsiDatetoPrettyDate $content]'
		where object_id=:object_id"
	} else {
	    db_dml add_description_100 "
		update sn_objects 
		set overview = '[util_AnsiDatetoPrettyDate $content]',
		    overview_html_p = 'f'
		where object_id=:object_id"
	}
    }

} elseif { [lsearch {object_link user_link content_link} $abstract_data_type] != -1 } {

    set sql_add_description_105 "
	select sw2.object_id, sw1.one_line_description as name
        from sn_links l, sn_objects sw1, sn_objects sw2 
        where l.object_id_a = sw2.object_id
            and l.object_id_b = sw1.object_id
            and l.question_id = :question_id
            and sw2.object_type_id = :object_type_id
	order by sw2.object_id, name"

    set last_object_id 0
    set names {}
    db_foreach add_description_105 $sql_add_description_105 {
	if { $last_object_id && $last_object_id != $object_id } {
	    if { $short_p } {
		db_dml add_description_110 "
		    update sn_objects 
		    set one_line_description = '[DoubleApos [join $names ", "]]'
		    where object_id=:last_object_id"
	    } else {
		db_dml add_description_120 "
		    update sn_objects 
		    set overview = '[DoubleApos [join $names ", "]]',
			overview_html_p = 'f'
		    where object_id=:last_object_id"
	    }
	    set names {}
	}

	lappend names $name

	set last_object_id $object_id
    }

    if { $last_object_id } {
	if { $short_p } {
	    db_dml add_description_130 "
		update sn_objects 
		set one_line_description = '[DoubleApos [join $names ", "]]'
		where object_id=:last_object_id"
	} else {
	    db_dml add_description_140 "
		update sn_objects 
		set overview = '[DoubleApos [join $names ", "]]',
		    overview_html_p = 'f'
		where object_id=:last_object_id"
	}
    }
}

ad_returnredirect "edit-question?[export_url_vars object_type_id question_id]"
