ad_page_contract {
    /packages/library/www/admin/branch-tree.tcl

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    
    @cvs-id $Id: branch-tree.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $
} {
    object_type_id
} -properties {
    questions:multirow
}

# Object type info for page display
set pretty_type [km_static object_type_pretty_name $object_type_id]
set graphic [km_static object_type_graphic $object_type_id]
set graphic_width [library_icon_width]

set sql_branch_tree_10 "
select question_id, level
from sn_question_object_type_map
where object_type_id = $object_type_id
    and (branch_p = 't' 
	 or question_id in (select parent_question_id from sn_question_object_type_map where branch_p = 't' and object_type_id = $object_type_id))
start with parent_question_id=[km_static km_dummy_object_id] and object_type_id=$object_type_id 
    and question_id in (select parent_question_id from sn_question_object_type_map where object_type_id = $object_type_id)
connect by prior question_id = parent_question_id and object_type_id = $object_type_id"

# Construct a tree with links to the individual branches

template::multirow create questions indentation_level indentation link
db_foreach branch_tree_10 $sql_branch_tree_10 {
    set pretty_question [snd [km_get_question $question_id $object_type_id]]

    template::multirow append questions $level [space -size [expr $level *5]] "<a href=\"view-branches?[export_url_vars question_id object_type_id]\">$pretty_question</a>"

}

set title "Branch Tree for $pretty_type"
set_context_bar_data [list "view-questions?object_type_id=$object_type_id" "$pretty_type Questions"] $title
ad_return_template
