ad_page_contract {
    /packages/library/www/admin/create-category-2.tcl

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    @author Jens Kordsmeier (jak@arsdigita.com)
    
    @cvs-id $Id: choose-category-2.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $
} {
    question_id
    object_type_id
    tree_id
    reset_categorization:optional
} -properties {
}
csrf::authenticate

# Get node_id for tree root
set node_id [db_string get_root_node {
    select root_node_id 
    from generic_trees
    where tree_id = :tree_id
}]

# Test if another visible question is already using this category.
set used_p [db_string check_uniqueness {
    select count(*) 
    from sn_questions q, sn_question_object_type_map qm
    where q.node_id = :node_id
	and q.question_id = qm.question_id
	and qm.object_type_id = :object_type_id
	and qm.question_state <> 'invisible'
	and q.question_id <> :question_id
}]

if { $used_p } {
    ad_return_complaint 1 "<li>The selected category is already used by another question of this object type."
    return
}

set old_node_id [km_get_node_id $question_id]

db_transaction {
    if { [info exists reset_categorization] && ![empty_string_p $old_node_id] && 
	 $node_id != $old_node_id } {

	# Remove categorization which may be left over from a previous
	# use of this category tree.

	db_dml delete_categorization {
	    delete from sw_object_category_map
	    where category_id in (select child_category_id
				  from sw_flat_cat
				  where parent = :node_id)
	    and object_id in (select object_id
			      from sn_objects
			      where object_type_id = :object_type_id)
	}
    }

    db_dml set_tree {
	update sn_questions 
	set tree_id = :tree_id, node_id = :node_id 
	where question_id = :question_id
    }
}

km_static -reset $question_id

ad_returnredirect "view-questions?[export_url_vars object_type_id]"
