ad_page_contract {
    /packages/library/www/admin/choose-category.tcl

    After creating a new question, let the user associate it
    with a category tree.

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    @author Jens Kordsmeier (jak@arsdigita.com)
    
    @cvs-id $Id: choose-category.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
    question_id
    object_type_id
} -properties {
}

set pretty_type [km_static object_type_pretty_name $object_type_id]
set pretty_plural [km_static object_type_pretty_plural $object_type_id]
set graphic [km_static object_type_graphic $object_type_id]

set user_id [ad_conn user_id]

set tree_id [db_string get_current_tree {
    select tree_id 
    from sn_questions
    where question_id = :question_id
}]

db_multirow category_trees category_trees "
    select g.tree_id, g.tree_name
    from generic_tree_types t, generic_trees g
    where t.tree_struct_table = 'sw_category_dim'
	and t.type_id = g.type_id
	and g.hidden_p = 'f'
	and (g.site_wide_p = 't'
	     [ad_decode $tree_id "" "" "or g.tree_id = :tree_id"]
	     or [tcl_permission_for_bind_vars_p "g.tree_id" ":user_id" "'category_tree_read'"] = 't')
	and g.root_node_id not in (select q.node_id
				   from sn_questions q, sn_question_object_type_map qm
				   where q.node_id is not null
				       and q.question_id = qm.question_id
				       and qm.object_type_id = :object_type_id
				       and qm.question_state <> 'invisible'
				       and q.question_id <> :question_id)
    order by lower(tree_name)
"

set pretty_question [snd [km_get_question $question_id $object_type_id]]

set title "Categories"
set_context_bar_data \
    [list "view-questions?object_type_id=$object_type_id" "$pretty_type Questions"] \
    $title

if { [empty_string_p $tree_id] } {
    set tree_name ""
} else {
    set tree_name [db_string choose_category_10 {
	select tree_name 
	from generic_trees
	where tree_id = :tree_id
    }]
}

set form_vars [export_form_vars question_id object_type_id]

ad_return_template
