ad_page_contract {
    /packages/library/www/admin/choose-presentation-type.tcl

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    @author Timo Hentschel (timo@arsdigita.com)
    @author Jens Kordsmeier (jak@arsdigita.com)
    
    @cvs-id $Id: choose-presentation-type.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $
} {
    question_id
    object_type_id
    {abstract_data_type ""}
    {presentation_type ""}
} -properties {
    tag_height:onevalue
    tag_width:onevalue
    presentation_type:onevalue
    pretty_question:onevalue
    abstract_data_type:onevalue
    title:onevalue
    form_vars:onevalue
    presentation_type_tags:multirow
    count_tags:onevalue
}

if [empty_string_p $abstract_data_type] {

    set attributes [km_get_questions -question_states {} -all_properties_p 1 -root_node_p 0 -question_ids [list $question_id]]
    set key [fst $attributes]
    set question [snd $attributes]
    set pretty_question [snd $question]
    set question_id [lindex $question [lsearch $key question_id]]
    set abstract_data_type [lindex $question [lsearch $key abstract_data_type]]
    set presentation_type [lindex $question [lsearch $key presentation_type]]
    set tag_height [lindex $question [lsearch $key tag_height]]
    set tag_width [lindex $question [lsearch $key tag_width]]
    set year_from [lindex $question [lsearch $key year_from]]
    set year_to [lindex $question [lsearch $key year_to]]

} else {
    
    set tag_height ""
    set tag_width ""
    set year_from "-5"
    set year_to "5"
    set presentation_type ""
    set pretty_question [db_string choose_presentation_type_10 "
	select pretty_name from sn_questions where question_id = :question_id"]
}

set object_type [km_static object_type_pretty_name $object_type_id]

#Decide which html tags  to offer on the basis of the abstract_data_types
switch $abstract_data_type {

    "text" { 
	set tags {shorttext textarea textarea_with_refs}
	set pretty_tags {"Short Text" "Textarea" "Textarea with Library/Web Reference Buttons"}
	if [empty_string_p $presentation_type] { set presentation_type "shorttext" }
    }

    "integer" {
	set tags {shorttext}
	set pretty_tags {"Short Text"}
	if [empty_string_p $presentation_type] { set presentation_type "shorttext" }
    }

    "option" - "other_category" -
    "category" { 
	set tags {select selectmultiple checkbox radio}
	set pretty_tags {"Select" "Select Multiple" "Checkbox" "Radio Buttons"}
	if [empty_string_p $presentation_type] { set presentation_type "select" }
    }
    "date" {
	set tags {custom select}
	set pretty_tags {"Custom" "Select"}
        set default_date [km_default_date $question_id]
        util_unlist $default_date year_value month_value day_value
	if [empty_string_p $presentation_type] { set presentation_type "custom" }
    }
    "nephew_object" {
	set tags {custom application}
	set pretty_tags {"Standard List of Objects" "List of Objects with Button for Application Form on Target Object Type Page"}
	if [empty_string_p $presentation_type] { set presentation_type "custom" }
    }
}

# Some demo items
set items [list "Products" "Sales" "Marketing" "Supply Chain"]

# Show the demo tags for selection

template::multirow create presentation_type_tags radio_row abstract_data_type tag items

foreach tag $tags {
    set pretty_tag [lindex $pretty_tags [lsearch $tags $tag]]
    if ![string compare $tag $presentation_type] {
	set check_string "checked" 
    } else {
	set check_string ""
    }
    set radio_row "<input type=radio name=\"presentation_type\" value=\"$tag\" $check_string>$pretty_tag"

    template::multirow append presentation_type_tags $radio_row $abstract_data_type $tag $items
}


set title "Presentation Type for $pretty_question"

set form_vars [export_form_vars object_type_id question_id]
set count_tags [llength $tags]

set_context_bar_data [list "view-questions?object_type_id=$object_type_id" "$object_type Questions"] $title

ad_return_template



