ad_page_contract {
    /packages/library/www/admin/choose-questions.tcl

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    
    @cvs-id $Id: choose-questions.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $
} {
    object_type_id 
    question_id 
} -properties {
    questions:multirow
    title:onevalue
    form_vars:onevalue
    tag:onevalue
}

set composite_id $question_id
set child_ids [km_get_child_questions $question_id]

set object_pretty_name [km_static object_type_pretty_name $object_type_id]
set question_list [km_branch_questions -root_question_id $question_id -composite_children_p 1 $object_type_id]
set key [head $question_list]
set question_list [tail $question_list]

set question_ids [fst [transpose $question_list]]

if ![null_p $child_ids] {
    set question_list [concat $question_list [tail [km_get_questions -question_states {active deprecated read-only} -all_properties_p 1 -root_node_p 0 -form_view 2 -question_ids $child_ids]]] 
}

template::multirow create questions pretty_name short_explanation question_state abstract_data_type presentation_type checkmark checked_string question_id url_vars 

if ![null_p $question_list] {
    foreach question $question_list {
        set pretty_name [lindex $question [lsearch $key pretty_name]]
        
        # Cut the entry explanation a bit smaller.
        set short_explanation [km_shorten_question [lindex $question [lsearch $key entry_explanation]]]
        
        set question_id [lindex $question [lsearch $key "question_id"]]
        set mandatory_p [ad_decode [lindex $question [lsearch $key mandatory_p]] t 1 0]
        set abstract_data_type [km_pretty_adt [lindex $question [lsearch $key "abstract_data_type"]]]
        set presentation_type [km_pretty_tag [lindex $question [lsearch $key "presentation_type"]]]
        set question_state [lindex $question [lsearch $key "question_state"]]

        if { $mandatory_p } {
            set checkmark "<img src=\"../graphics/check.gif\" width=16 height=16 border=0>"
        } else {
            set checkmark "&nbsp;"
        }
        if { [lsearch $child_ids $question_id] >= 0 } { 
            set checked_string "checked"
        } else {
            set checked_string ""
        }
        
        set url_vars [export_url_vars object_type_id question_id]
        template::multirow append questions $pretty_name $short_explanation $question_state \
                $abstract_data_type $presentation_type $checkmark $checked_string $question_id $url_vars 
    }
}

set tag ""
set title "Composite Question"
set form_vars [export_form_vars composite_id object_type_id]

set_context_bar_data [list "view-questions?object_type_id=$object_type_id" "$object_pretty_name Questions"] $title

ad_return_template
