set package_id [ad_conn package_id]
set user_id [auth::require_login]

set list_of_instances {}
template::multirow create instances package_id instance_name community_name

db_foreach get_libraries_with_admin "
    select p1.package_id, p1.instance_name, p2.instance_name as community_name
    from apm_packages p1, apm_packages p2, sn_community_instances ci
    where p1.package_key='library' 
	and [tcl_permission_for_bind_vars_p "p1.package_id" ":user_id" "'admin'"] = 't'
	and p1.package_id <> :package_id
        and p2.package_id = ci.community_id
        and p1.package_id = ci.package_id
    order by lower(community_name), lower(p1.instance_name)
" {
    template::multirow append instances $package_id $instance_name $community_name
}


