# /www/admin/library/edit-all-questions.tcl
#
# Takes in a bunch of question_id-sort_key form vars and resorts them numerically
# so that there is always a gap of 10 between them and NO duplicates or empty values.
# Also updates mandatory_p.
#
# $Id: edit-all-questions.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $
csrf::authenticate

set_the_usual_form_variables

set i 0
set size [ns_set size $Vform]

set mandatory_questions {}
while {$i<$size} {
    if { [ns_set key $Vform $i] == "mandatory_p"} {
	lappend mandatory_questions [ns_set value $Vform $i]
    }
    incr i
}

set all_question_ids [fst [transpose [tail [km_get_questions -question_states {active deprecated read-only} -branch_children_p 0 -root_node_p 0 -object_type_id $object_type_id]]]]
set not_mandatory_questions [minus $all_question_ids $mandatory_questions]

if ![null_p $mandatory_questions] {
    db_dml edit_all_questions_10 "
	update sn_question_object_type_map 
	set mandatory_p = 't'
        where object_type_id = :object_type_id
	    and question_id in ([join $mandatory_questions " , "])
	    and question_state = 'active'"

    db_dml edit_all_questions_20 "
	update sn_question_object_type_map 
	set mandatory_p ='f'
        where object_type_id = :object_type_id
	    and (question_id not in ([join $mandatory_questions ","]) or question_state <> 'active')"

    db_dml edit_all_questions_30 "
	update sn_question_object_type_map qm
	set mandatory_p = 't'
	where object_type_id=:object_type_id
	    and (select abstract_data_type from sn_questions q where q.question_id=qm.question_id) = 'composite'
	    and qm.question_state = 'active'
	    and qm.question_id in
		(select parent_question_id 
		 from sn_question_object_type_map
		 where object_type_id=:object_type_id
		 start with question_id in ([join $mandatory_questions ","]) 
		    and object_type_id=:object_type_id
		 connect by prior parent_question_id = question_id)"

} else {
    db_dml edit_all_questions_40 "
	update sn_question_object_type_map 
	set mandatory_p='f'
        where object_type_id = :object_type_id"
}

# Sort out the sort_key form variables

set sort_tuples {}
set size [ns_set size $Vform]
set i 0
while { $i < $size } { 
    set key [ns_set key $Vform $i]
    set value [ns_set value $Vform $i] 
    if [integer_p $key] {
	#Then it's one of the question sort_key tag
	lappend sort_tuples [list $key $value]
    }
    incr i
}

# Sort the variables for the sort_key column in sn_questions
set sort_tuples [qsort $sort_tuples snd]
set i 10

foreach tuple $sort_tuples {
    set question_id [fst $tuple]
    db_dml edit_all_questions_50  "
	update sn_question_object_type_map 
	set sort_key = :i
        where question_id = :question_id and object_type_id = :object_type_id"
    incr i 10
}

ad_returnredirect "view-questions?[export_url_vars object_type_id]"
