ad_page_contract {
    /packages/library/www/admin/edit-branch-2.tcl

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    
    @cvs-id $Id: edit-branch-2.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $
} {
    question_id:integer
    object_type_id:integer
    branch_answer
    operator
    branch_id:integer
} 
csrf::authenticate

# If the branch answer is a foreign key then we store it somewhere else than when
# it is a varchar- To figure this out we look at the abstract_data_type

set abstract_data_type [db_string edit_branch_2_10 "select abstract_data_type
  from sn_questions
  where question_id=:question_id" -default ""]

switch $abstract_data_type {
    "integer" -
    "text" {
	set column "branch_answer"
	set branch_answer '[DoubleApos $branch_answer]'
    }
    "option" -
    "category" -
    "other_category" { set column "branch_answer_foreign_key" }
    default { ad_returnredirect "view-questions?[export_url_vars object_type_id]" }
}

db_transaction {
    # Delete the old branch for this answer.
    db_dml edit_branch2_10 "
    update sn_question_object_type_map
    set parent_question_id = [km_static km_dummy_object_id], branch_p = 'f', branch_operator = null, $column = null
    where parent_question_id = $question_id 
    and object_type_id = $object_type_id
    and branch_operator = '$operator'
    and $column = $branch_answer
    and branch_p = 't'"
    
    # Create the new branch.
    
    db_dml edit_branch2_20 "
    update sn_question_object_type_map 
    set parent_question_id = $question_id, branch_p = 't',
    branch_operator = '$operator', $column = $branch_answer
    where question_id = $branch_id and object_type_id=$object_type_id"
    
}

##km_static -reset

ad_returnredirect "view-branches?[export_url_vars question_id object_type_id]"
