ad_page_contract {

} {
    question_id
    {mandatory_p 0}
    {first_form_p 0}
    object_type_id
    abstract_data_type
    {question_state "active"}
    {order_by ""}
    {default_value ""}
    {pretty_name ""}
    {entry_explanation ""}
    {refers_to "null"}
    {defaults_question_id "null"}
    {max_categories "null"}
    {browse_p ""}
}
csrf::authenticate

#if {[doubleclick::check_all]} {
#    ns_log Notice "Going to sleep to avoid a race condition"
#    ns_sleep 10
#    ad_returnredirect "view-questions?object_type_id=$object_type_id"
#    return
#}

# First we have to set some things so that we don't have invisible mandatory questions etc.
set link_types [list object_link content_link user_link]
if { [lsearch $link_types $abstract_data_type] != -1 } {    
     set first_form_p 0    
} 

if { $question_state != "active" } { 
    set mandatory_p 0 
}

set form_number $first_form_p
set mandatory_p [ad_decode $mandatory_p 1 "t" "f"]

set exists_p [db_string edit_question_2_10 "
    select decode(count(*),0,0,1) from sn_questions 
    where question_id=:question_id"]

set context_id [ad_conn package_id]
set user_id [ad_conn user_id]
set creation_ip [ad_conn peeraddr]
 
if {[empty_string_p $defaults_question_id]} { set defaults_question_id "null" }
if {[empty_string_p $max_categories]} { set max_categories "null" }
if {[empty_string_p $browse_p] || $browse_p} {
    set browse_p "t"
} else {
    set browse_p "f"
}

if {!$exists_p} {
    switch -exact $abstract_data_type {
	"category" - "other_category" - "option" { set presentation_type "select" }
	"integer" { set presentation_type "shorttext" }
	default { set presentation_type "custom" }
    }

    set dummy [db_exec_plsql admin_edit_question_2_20 "
	begin
	:1 := question.insert_question (
	v_question_id => :question_id,
	v_pretty_name => :pretty_name,
	v_abstract_data_type => :abstract_data_type,
	v_order_by => :order_by, 
	v_default_value => :default_value,
	v_entry_explanation => :entry_explanation, 
	v_creation_user => :user_id,
	v_creation_ip => :creation_ip,
	v_context_id => :context_id,
        v_references_q_id => $refers_to
	);
	end;
    "]

} else {
    db_exec_plsql admin_edit_question_2_30 "
        begin
        question.update_question (
        v_question_id => :question_id,
	v_pretty_name => :pretty_name,
        v_abstract_data_type => :abstract_data_type,
        v_order_by => :order_by, 
        v_default_value => :default_value,
        v_entry_explanation => :entry_explanation, 
        v_modifying_user => :user_id,
        v_modifying_ip => :creation_ip,
        v_references_q_id => $refers_to,
        v_def_question_id => $defaults_question_id,
        v_max_categories => $max_categories,
        v_browse_p => :browse_p
        );
        end;"

    if {[db_string get_questions_browse_p { select browse_p from sn_questions where question_id = :question_id}] != $browse_p} {
	km_flush_category_count -object_type_id $object_type_id
    }
}

km_static -reset $question_id

if {![db_0or1row edit_question_2_40 "
    select question_state as old_state, parent_question_id, decode(branch_p,'t',1,0) as branch_p
    from sn_question_object_type_map
    where question_id = :question_id and object_type_id = :object_type_id"]} {
    set old_state ""
    set parent_question_id 0
    set branch_p 0
}

if {[empty_string_p $parent_question_id] || $parent_question_id == [km_static km_dummy_object_id]} { 
    set parent_question_id 0 
}
if {[empty_string_p $branch_p]} { 
    set branch_p 0 
}

if { $parent_question_id && !$branch_p && $mandatory_p } {
    # This is a mandatory child question of a composite question.
    # Make sure that the parent question is made mandatory, too.

    db_dml edit_question_2_50 "
	update sn_question_object_type_map
	set mandatory_p = 't'
	where question_id = :parent_question_id
	    and object_type_id = :object_type_id"
}

if { $abstract_data_type == "composite" } {
    # Make sure the child questions have a sensible question state.
    # If the parent question has become invisible, all children
    # must be invisible, too.
    # If the parent question is made visible, we use the new
    # question_state for its children, too.

    set sql_edit_question_2_60 "
	select question_id as child_id, question_state as child_state
	from sn_question_object_type_map
        where parent_question_id = :question_id
	    and object_type_id = :object_type_id"

    db_foreach edit_question_2_60 $sql_edit_question_2_60 {
	if { $question_state == "invisible" && $child_state != "invisible" } {
	    db_dml edit_question_2_70 "
		update sn_question_object_type_map 
		set question_state = 'invisible'
		where question_id = :child_id"
	} elseif { $old_state == "invisible" && $question_state != "invisible" && $child_state == "invisible" } {
	    db_dml edit_question_2_80 "
		update sn_question_object_type_map 
		set question_state = :question_state
		where question_id = :child_id"
	}
    }
}

# Check if the question is the root of a branch. If it is and 
# its visibility has changed, we have to update the visibility
# of the children, too.

if {[km_root_branch_p $question_id]} {
    set sql_edit_question_2_90 "
	select question_id as child_id, question_state as child_state
	from sn_question_object_type_map
	start with parent_question_id = $question_id and object_type_id=$object_type_id
        connect by parent_question_id = prior question_id and object_type_id=$object_type_id"

    db_foreach edit_question_2_90 $sql_edit_question_2_90 {
	if { $question_state == "invisible" && $child_state != "invisible" } {
	    db_dml edit_question_2_100 "
		update sn_question_object_type_map 
		set question_state = 'invisible'
		where question_id = :child_id"
	} elseif { $old_state == "invisible" && $question_state != "invisible" && $child_state == "invisible" } {
	    db_dml edit_question_2_110 "
		update sn_question_object_type_map 
		set question_state = '$question_state'
		where question_id = :child_id"
	}
    
    }
}

# Update sn_question_object_type_map.
if {[empty_string_p $old_state]} {
    set max_sort_key [db_string edit_question_2_120 "
	select max(sort_key) from sn_question_object_type_map
        where object_type_id = :object_type_id"]
    
    set calculcated_max_sort_key [expr $max_sort_key + 10]
    db_dml edit_question_2_130 "
	insert into sn_question_object_type_map
        (object_type_id, question_id, form_number, mandatory_p, question_state, branch_p, sort_key)
        values (:object_type_id, :question_id, :form_number, :mandatory_p, 
	:question_state, 'f', :calculcated_max_sort_key)"
} else {
    db_dml edit_question_2_140 "
	update sn_question_object_type_map 
	set form_number = :form_number, mandatory_p = :mandatory_p, question_state = :question_state
        where object_type_id = :object_type_id and question_id = :question_id"
}


# If a question has become invisible or visible, this affects fulltext search,
# so ask the user if we should rebuild the Intermedia index for this
# object type.

if {![empty_string_p $old_state]} {
    if { $old_state != $question_state && 
	 ($old_state == "invisible" || $question_state == "invisible") } {
	if { $question_state != "invisible" } {
	    # Make sure that no two visible questions have the same sort_key.

	    set duplicate_p [db_string edit_question_2_150 "
		select decode(count(*),0,0,1) 
		from sn_question_object_type_map
		where object_type_id=:object_type_id
		    and question_id <> :question_id
		    and sort_key = (select sort_key from sn_question_object_type_map 
				    where object_type_id=:object_type_id 
					and question_id=:question_id)"]

	    if {$duplicate_p} {
		db_dml edit_question_2_160 "
		update sn_question_object_type_map
		set sort_key = 
		    (select max(sort_key)+10 
		     from sn_question_object_type_map 
		     where object_type_id = :object_type_id)
		where question_id=:question_id and object_type_id=:object_type_id"
	    }
	}

        set pretty_type_plural [km_static object_type_pretty_plural $object_type_id]
        set title $pretty_name
        set form_vars [export_form_vars object_type_id]
        set_context_bar_data [list "view-questions?object_type_id=$object_type_id" "$pretty_name Questions"] $title
        ad_return_template edit-question-2
    } else {
        set destination "view-questions"
        ad_returnredirect "$destination?[export_url_vars question_id object_type_id abstract_data_type]"

        # We don't want the template to be parsed.
        return
    }
} else {
    switch $abstract_data_type {
	"text" { set destination "choose-presentation-type" }
	"category" - "other_category" { set destination "choose-category" }
	"option" { set destination "add-option" }
	"integer" { set destination "view-questions" }
	"composite" { set destination "choose-questions" }
	"child_object" - "nephew_object" -
	"object_link" { set destination "choose-object-type" }
	"default" { set destination "view-questions" }
    }
    ad_returnredirect "$destination?[export_url_vars question_id object_type_id abstract_data_type]"

    # We don't want the template to be parsed.
    return
} 

