ad_page_contract {
    /packages/library/www/admin/index.tcl

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    
    @cvs-id $Id: index.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
} -properties {
    context_bar:onevalue
    instance_name:onevalue
    form_vars:onevalue
    instances_with_admin_rights:onevalue
    object_types:multirow
    feedback_category_admin_link:onevalue
    feedback_category_options_admin_link:onevalue
    xchange_category_admin_link:onevalue
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]

set display_copy_link_p f
template::multirow create object_types object_type_id object_id_form_var pretty_plural browse_html public_html graphic_html sort_key checkmark

db_foreach object_type {
    select object_type_id, pretty_plural, browse_p, public_p, graphic, sort_key
    from sn_object_types
    where deleted_p = 'f' and context_id = :package_id
    order by sort_key
} {
    if {![empty_string_p $graphic]} {
        set graphic_html "<a href=\"../browse-one-type?object_type_id=$object_type_id\"><img src=\"/library-files/$graphic\" height=[library_icon_height] width=[library_icon_width] border=0></a>"
    } else {
	set graphic_html ""
    }
    set checkmark "<img src=\"../graphics/check.gif\" width=16 height=16 border=0>"
    set browse_html [ad_decode $browse_p t $checkmark "&nbsp;"]
    set public_html [ad_decode $public_p t $checkmark "&nbsp;"]
    set object_id_form_var [export_url_vars object_type_id]
    template::multirow append object_types $object_type_id $object_id_form_var $pretty_plural $browse_html $public_html $graphic_html $sort_key $checkmark
    set display_copy_link_p t
}

set return_url "."
set table_name "sn_object_types"
set key_column "object_type_id"
set form_vars [export_form_vars table_name key_column return_url]

# Let's see if this user has admin rights for more than one library instance.
# Variable kept for backward compatibility.
set instances_with_admin_rights 2

set feedback_category_admin_link "categories/one-object?object_id=$package_id"
set feedback_category_root_node_id [db_string get_assigned_feedback_tree {
    select octr.subtree_root_node_id as root_node_id
    from generic_trees gt, acs_rels ar, object_category_tree_rels octr
    where ar.object_id_one = :package_id
	and ar.object_id_two = gt.tree_id
        and ar.rel_id = octr.rel_id	 
	and rel_type = 'object_category_tree_rel' } -default ""]

if { ![empty_string_p $feedback_category_root_node_id ] } {
    set feedback_category_options_admin_link "feedback-category-options?root_node_id=$feedback_category_root_node_id&object_id=[ad_conn package_id]"
}

set xchange_p [db_string application_nephew_question_p {
    select count(*)
    from sn_questions q, sn_question_object_type_map qm, sn_object_types ot
    where q.abstract_data_type = 'nephew_object'
    and q.presentation_type = 'application'
    and q.question_id = qm.question_id
    and qm.object_type_id = ot.object_type_id
    and ot.context_id = :package_id
}]

if { $xchange_p } {
    set xchange_category_admin_link "xchange-categories"
} else {
    set xchange_category_admin_link ""
}

set ApprovalProcessP  [km_static approval_p $package_id]

if {$ApprovalProcessP} {
	db_multirow approval_coordinators get_approval_coordinators {
            select ac.coordinator_id, u.first_names, u.last_name,  u.email
            from approval_coordinators ac, users u
            where ac.package_id=:package_id
            and ac.coordinator_id=u.user_id
        }
}

set_context_bar_data
set csrf_link [csrf::link_token]

ad_return_template
