ad_page_contract {
    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
} {
    object_type_id:integer
    move_to_package_id:integer
} -properties {
    context_bar:onevalue
}
csrf::authenticate

ad_require_permission $move_to_package_id "admin"
ad_require_permission $object_type_id "admin"

set this_package_id [ad_conn package_id]
set ip_address [ns_conn peeraddr]
set user_id [ad_get_user_id]

db_transaction {
    db_dml move_object_type_2_10 {update acs_objects
    set context_id = :move_to_package_id,
    last_modified = sysdate,
    modifying_user = :user_id,
    modifying_ip = :ip_address
    where object_id in
    (select object_id 
    from sn_objects
    where object_type_id = :object_type_id)}

    db_dml update_type_context {
	update acs_objects
	set context_id = :move_to_package_id
	where object_id = :object_type_id
    }

    db_dml move_object_type_2_20 {update acs_objects_description
    set package_id = :move_to_package_id
    where object_id in
    (select object_id 
    from sn_objects
    where object_type_id = :object_type_id)}

    db_dml move_object_type_2_30 {update sn_objects
    set context_id = :move_to_package_id
        where object_type_id = :object_type_id}

    db_dml move_object_type_2_40 "update sn_object_types
    set context_id = :move_to_package_id
    where object_type_id = :object_type_id"

    db_dml move_object_type_2_50 "update sn_table_name_map
    set context_id = :move_to_package_id
    where object_type_id = :object_type_id"
}

##km_static -reset $object_type_id

ad_returnredirect index
