# /www/admin/library/sort-keys.tcl
#


# $Id: sort-keys.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $

ad_page_contract {

    Takes in a bunch of object_type_id-sort_key form vars and resorts them
    numerically so that there is always a gap of 10 between them and NO
    duplicates or empty values.

    @author Dirk
    @cvs-id $Id: sort-keys.tcl,v 1.1 2003/07/02 12:19:44 peterm Exp $
} {
    table_name:trim,notnull
    key_column:trim,notnull
    return_url:
}

set form [ns_conn form]
set form_size [ns_set size $form]

set tuples {}
set i 0
while { $i < $form_size } { 
    set key [ns_set key $form $i]
    set value [ns_set value $form $i] 
    if [integer_p $key] {
	# Then it's one of the sort_key tags.
	lappend tuples [list $key $value ]
    }
    incr i
}

# Preliminery sort
set tuples [qsort $tuples snd]

set i 10

foreach tuple $tuples {
    set sort_key $i
    set id [fst $tuple]
    db_dml sort_keys "update $table_name set sort_key = :sort_key where $key_column = :id"
    incr i 10
}

ad_returnredirect $return_url


