# $Id: view-branches.tcl,v 1.1 2003/07/02 12:19:45 peterm Exp $
ad_page_contract {

    @author Dirk
    @cvs-id $Id: view-branches.tcl,v 1.1 2003/07/02 12:19:45 peterm Exp $
} {
    object_type_id:integer
    question_id:integer
} -properties {
    title:onevalue
    branches:multirow
    add_branch_link_p:onevalue
    question_state:onevalue
    add_branch_link:onevalue
}

set question_info [km_get_question $question_id $object_type_id]
set pretty_question [snd $question_info]
set question_state [lindex $question_info 3]

set existing_branches [km_get_branches -question_attributes_p 1 $question_id $object_type_id]
set key [fst $existing_branches]
set branch_list [tail $existing_branches]

set default_branch [km_default_branch $question_id]

template::multirow create branches branch_operator branch_answer checkmark pretty_name entry_explanation presentation_type abstract_data_type edit_link delete_link

if ![null_p $branch_list] {
    foreach branch $branch_list {
	set branch_answer [lindex $branch [lsearch $key branch_answer]]
	set branch_operator [lindex $branch [lsearch $key branch_operator]]
	set entry_explanation [km_shorten_question [lindex $branch [lsearch $key entry_explanation]]]
	set pretty_name [lindex $branch [lsearch $key pretty_name]]
	set presentation_type [km_pretty_tag [lindex $branch [lsearch $key presentation_type]]]
	set abstract_data_type [km_pretty_adt [lindex $branch [lsearch $key abstract_data_type]]]
	set branch_id [lindex $branch [lsearch $key question_id]]
	
	if [empty_string_p $branch_operator] { set branch_operator "&nbsp;" }
	if { $branch_id == $default_branch } {
	    set checkmark "<img src=\"../../graphics/check.gif\" width=16 height=16>"
	} else {
	    set checkmark "&nbsp;"
	}

        set edit_link "<a href=\"edit-branch?[export_url_vars question_id branch_id object_type_id]\">"
        set delete_link "<a href=\"delete-branch?[export_url_vars question_id branch_id object_type_id]\">"

        template::multirow append branches $branch_operator $branch_answer $checkmark $pretty_name $entry_explanation $presentation_type $abstract_data_type $edit_link $delete_link
    }
}

if { $question_state != "read-only" && $question_state != "invisible" } {
    set add_link ""
} else {
    set add_link ""
}

if { $question_state != "read-only" && $question_state != "invisible" } {
    set add_branch_link_p t
    set question_state ""
    set add_branch_link "<a href=\"edit-branch?[export_url_vars question_id object_type_id]\">"
} else {
    set add_branch_link_p f
    set question_state "[km_pretty_question_state $question_state]"
    set add_branch_link ""
}



set title "Navigational Branches for $pretty_question"
set_context_bar_data \
    [list "." "Knowledge Library"] \
    [list "view-questions?object_type_id=$object_type_id" "All Questions"] \
    $title

set object_type_name [db_string view_branches_20 "select pretty_name
  from sn_object_types 
  where object_type_id=:object_type_id"]


set_context_bar_data [list "view-questions?object_type_id=$object_type_id" "$object_type_name Questions"] $title
ad_return_template
