# $Id: view-options.tcl,v 1.1 2003/07/02 12:19:45 peterm Exp $
ad_page_contract {

    @author Dirk
    @cvs-id $Id: view-options.tcl,v 1.1 2003/07/02 12:19:45 peterm Exp $
} {
    question_id:integer
    object_type_id:integer
    {invisible_p 0}
} -properties {
    options:multirow
    add_option_link_p:onevalue
    question_state:onevalue
    add_option_link:onevalue
}

set pretty_type [km_static object_type_pretty_name $object_type_id]
set graphic [km_static object_type_graphic $object_type_id]

set question_info [km_get_question $question_id $object_type_id]
set pretty_question [snd $question_info]
set question_state [lindex $question_info 3]

set return_url "view-options?[export_url_vars question_id object_type_id]"
set table_name "sn_answer_options"
set key_column "option_id"
set form_vars [export_form_vars table_name key_column return_url invisible_p]

# dig out the existing multiple choice options for this question
set option_list [km_get_answer_options $question_id]

template::multirow create options answer_option input_tag edit_link delete_link

if ![null_p $option_list] {
    foreach option $option_list {
	set option_id [fst $option]
	set answer_option [snd $option]
	set sort_key [thd $option]

        set input_tag "<input type=text size=4 name=$option_id value=\"$sort_key\">"
        set edit_link "<a href=\"edit-option?[export_url_vars option_id question_id object_type_id]\">"
        set delete_link "<a href=\"delete-option?[export_url_vars option_id question_id object_type_id]\">"
        template::multirow append options $answer_option $input_tag $edit_link $delete_link
    }
}


if { $question_state != "read-only" && $question_state != "invisible" } {
    set add_option_link_p t
    set question_state ""
    set add_option_link "<a href=\"add-option?[export_url_vars object_type_id question_id]\">"
} else {
    set add_option_link_p f
    set question_state "[km_pretty_question_state $question_state]"
    set add_option_link ""
}
set pretty_question [db_string view_options_10 "select pretty_name
  from sn_questions
  where question_id = :question_id"]
set title "Multiple Choice Options for $pretty_question"
set_context_bar_data [list "view-questions?object_type_id=$object_type_id&invisible_p=$invisible_p" "$pretty_type Questions"] $title
ad_return_template
