ad_page_contract {
    /packages/library/www/admin/view-sample-form.tcl

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    
    @cvs-id $Id: view-sample-form.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
    object_type_id:integer
} -properties {
    context_bar:onevalue
    title:onevalue
    pretty_type:onevalue
    form_type:onevalue
    questions:multirow
}

set user_id [auth::require_login]

if {![km_check_object_type_id $object_type_id]} {
    return
}

# Object type info for page display
set pretty_type [km_static object_type_pretty_name $object_type_id]
set graphic [km_static object_type_graphic $object_type_id]

template::multirow create questions pretty_name entry_explanation field

set question_list [db_list_of_lists sql_view_sample_form_10 "select q.question_id
  from sn_questions q, sn_question_object_type_map m
  where q.question_id=m.question_id and
      m.object_type_id=:object_type_id and
      (m.parent_question_id = [km_static km_dummy_object_id] or m.branch_p='t') and
      m.question_state = 'active'
	order by m.sort_key"]

set title "Sample input form for $pretty_type"

set_context_bar_data [list "view-questions?[export_url_vars object_type_id]" "$pretty_type Questions"] "Sample Form"

ad_return_template
