ad_page_contract {
    /packages/library/www/comment-delete-2.tcl
 
    Allow the admin to delete feedback
 
    @author Timo Hentschel (timo@arsdigita.com)
 
    @cvs-id $Id: comment-delete-2.tcl,v 1.3 2005/03/01 00:01:14 jeffd Exp $
} {
    comment_id:notnull,integer
    {category_id ""}
    {path_id ""}
}
 
csrf::authenticate
set user_id [auth::require_login]
set package_id [ad_conn package_id]
set object_id [km_check_comment_id $user_id $comment_id]
if !$object_id { return }

set admin_p [km_conn admin_p]

if {!$admin_p} {
    ad_return_complaint 1 "Only admins can delete feedback!"
    return
}
 
set object_name [sn_striphtml [km_conn object_name]]
set object_type [km_static object_type_pretty_name [km_conn object_type_id]]

set category_forward_email ""
set scale 0

set return_url "object-view?[export_url_vars object_id category_id path_id]"

db_1row get_comment_data {
    select sc.content, sc.html_p, c.long_name as feedback_category
    from sn_comments sc, categories c
    where comment_id=:comment_id
    and sc.category_id = c.category_id(+) }

db_transaction {
    # remove the feedback from yellow pages
    db_dml delete_content_area {
	delete from acs_object_areas
	where object_id = :comment_id
    }

    # remove the feedback
    db_exec_plsql delete_feedback {
        begin
        sn_comment.delete_comment ( :comment_id );
        end;
    }
 
    if { $html_p == "t" } { set comment [ad_html_to_text -- $content] }

    set author_id [km_conn original_author_id]
    set author_email [km_conn original_author_email]

    db_1row object_info {
	select u.email as sender_email, 
	    u.first_names || ' ' || u.last_name as sender_name,
	    site_node.url(sn.node_id) as package_url
	from users u, site_nodes sn
	where u.user_id = :user_id
	    and sn.object_id = :package_id
    }

    set replacement_list \
            [list \
		 knowledge_object	    $object_name \
		 knowledge_object_link      [ad_url]${package_url}object-view?object_id=$object_id \
		 knowledge_object_type      $object_type \
		 feedback_type		    $feedback_category \
		 recipient_email	    $author_email \
		 sender_email	            $sender_email \
		 sender_name		    $sender_name \
		 comment		    $content]
 
    # This uses sn_community_instances_all.  Should it be using
    # sn_community_mounts_all instead?
    set package_id [ad_conn package_id]
    set community_id [db_string get_community_id {
        select community_id
        from sn_community_instances_all
        where package_id = :package_id }]
 
    et_queue_email [et_process -community_id $community_id "km_object_feedback_delete" $replacement_list]
}
 
ad_returnredirect $return_url
