ad_page_contract {
    /packages/library/www/comment-delete.tcl
 
    Allow the admin to delete feedback
 
    @author Timo Hentschel (timo@arsdigita.com)
 
    @cvs-id $Id: comment-delete.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    comment_id:notnull,integer
    {category_id ""}
    {path_id:integer ""}
} -properties {
    title:onevalue
    object_name:onevalue
    overview_with_href_and_mailto:onevalue
    content:onevalue
    author:onevalue
    admin_p:onevalue
    rating:onevalue
    scale:onevalue
    feedback_category:onevalue
    form_vars:onevalue
    form_vars_cancel:onevalue
    dc_export:onevalue
    subsite_url:onevalue
    subsite_name:onevalue
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]
 
set object_id [km_check_comment_id $user_id $comment_id]
if !$object_id { return }

set object_name [km_conn object_name]

db_1row get_comment_data {
    select sc.content, sc.html_p, rating, scale,
           c.long_name as feedback_category, sc.display_p as public_p,
           u.first_names || ' ' || u.last_name as author
    from sn_comments sc, categories c, users u
    where comment_id=:comment_id
    and sc.category_id = c.category_id(+)
    and u.user_id = sc.user_id }

set admin_p [km_conn admin_p]

if {!$admin_p} {
    ad_return_complaint 1 "Only admins can delete feedback!"
    return
}
 
set title "Delete feedback on \"$object_name\""
set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Delete feedback"
set overview_with_href_and_mailto [util_make_href_and_mailto_links [km_conn overview]]
set form_vars [export_form_vars comment_id category_id path_id]
set form_vars_cancel [export_form_vars object_id category_id path_id]

array set node [site_node_closest_ancestor_site_node "acs-subsite"]
set subsite_url $node(url)
set subsite_name $node(instance_name)

if { [string eq $html_p "f"] } {
    set content [ad_quotehtml $content]
}
 
set dc_export [doubleclick::signature_html]
 
ad_return_template
