ad_page_contract {
    $Id: content-link-add.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    target:integer,notnull
    pass:integer,notnull
    link_comment
}
csrf::authenticate

if ![path_valid_p $pass] {
    ad_return_error "Invalid Path" \
	"The current path ID is invalid. Perhaps you used your browser's Back button
	 and tried to add another user?"
    return
}
set object_id $target
set user_id [auth::require_login]

# Determine to which object we are going to add the user reference,
# and if the current user is allowed to do this.

set values [get_path_values -action_only_p 0 $pass]
set object_id_a [value_from_tuples $values object_id]
set question_id [value_from_tuples $values question_id]

if ![km_check_object_id -check_edit_p 1 $object_id_a] { return }

ad_permission_p $target read

# Hardcoding the link type_id here.
set link_type bi_directional

set exists_p [db_string content_link_add_10 "
    select decode(count(*),0,0,1) from sn_links 
    where object_id_a=:object_id_a and object_id_b=:object_id"]

if {!$exists_p} {
    db_transaction {

    set new_link_id [db_string content_link_add_15 "select sn_links_seq.nextval from dual"]

    db_dml content_link_add_20 "
    insert into sn_links (link_id, link_type, object_id_a, object_id_b, 
	creation_user, creation_date, link_comment)
    select :new_link_id, 'bi_directional', :object_id_a, :object_id, 
	:user_id, sysdate, :link_comment
    from dual
    where not exists (select 1 from sn_links 
		      where object_id_a=:object_id_a and object_id_b=:object_id)"

    db_dml content_link_add_25 "
    insert into sn_question_link_map (link_id, question_id)
    values (:new_link_id, :question_id)"

    db_dml content_link_add_30 "
	update acs_objects
	set last_modified = sysdate, modifying_user = :user_id
	where object_id = :object_id_a"

    db_dml content_link_add_35 "
	update sn_objects
	set last_modified = sysdate, last_modifying_user_id = :user_id
	[km_link_description_update $object_id_a $question_id]
	where object_id = :object_id_a"

    db_dml content_link_add_40 "
	update acs_objects_description
	set state = state
	where object_id = :object_id_a"

    set one_line_desc [db_string content_link_add_50 "select shortname
    from acs_objects_description 
    where object_id=:object_id"]

    set audit_comment "Added link to \"$one_line_desc\""
    db_dml content_link_add_60  {
	insert into sn_audit_table 
	(object_id, question_id, last_modified, last_modifying_user_id, content)
    values (:object_id_a, :question_id, sysdate, :user_id, :audit_comment)}

}
}

# All done, back to the path's origin.

ad_returnredirect [get_path_return_url $pass]
