# /www/library/content-link-delete-2.tcl
#
# Delete an object-content link.
#
# $Id: content-link-delete-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $

ad_page_variables {
    link_id
    return_url
}
csrf::authenticate

set user_id [auth::require_login]

# We are dealing with object <-> content links here.
# The following query relies on the object being
# referenced by the object_id_a column.

if {![db_0or1row content_link_delete_2_10 "
    select obj1.object_id, obj2.shortname as one_line_description, map.question_id
    from sn_links l, sn_objects obj1, acs_objects_description obj2, sn_question_link_map map
    where l.link_id=:link_id 
	and obj1.object_id = l.object_id_a
	and obj2.object_id = l.object_id_b
        and l.link_id = map.link_id"]} {
    # The link already has been deleted.
    ad_returnredirect $return_url
    return
}

# Check if the user is authorized to delete this link.

if ![ad_permission_p $object_id write] {
    ad_return_error "Not authorized" "You are not authorized to delete this link."
    return
}

# All checks passed - let's delete the row.

set audit_comment "Deleted link to '$one_line_description'"

db_transaction {
    db_dml content_link_delete_2_20 "delete from sn_links where link_id=:link_id"
    db_dml content_link_delete_2_21 "delete from sn_question_link_map where link_id=:link_id"

    db_dml content_link_delete_2_40 {
	insert into sn_audit_table 
	(object_id, question_id, last_modified, last_modifying_user_id, content)
	values (:object_id, :question_id, sysdate, :user_id, :audit_comment)}

    db_dml content_link_delete_2_50 "
	update sn_objects 
	set last_modified = sysdate, last_modifying_user_id = :user_id
	[km_link_description_update $object_id $question_id]
	where object_id = :object_id"
}

ad_returnredirect $return_url
