ad_page_contract {
    /www/library/delete-audit-trail.tcl

    Delete a single row from sn_audit_table. Only admins may do this.

    @cvs-id $Id: delete-audit-trail.tcl,v 1.1 2003/07/02 12:19:42 peterm Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    rowid:notnull
}
csrf::authenticate

ad_require_permission [ad_conn package_id] "admin"

set last_item [db_string last_item {
    select max(rowid)
    from sn_audit_table 
    where last_modified = (select max(last_modified) 
			   from sn_audit_table 
			   where object_id = :object_id)
}]

set del_rowid $rowid

db_transaction {

    db_dml delete_audit_trail "delete from sn_audit_table where rowid=:del_rowid"

    if { $last_item == $rowid } {
	# If we just deleted the last audit item, we have to update the object timestamp.
	db_dml update_last_modified {
	    update sn_objects
	    set last_modified = (select max(last_modified) 
	                         from sn_audit_table 
	                         where object_id = :object_id)
	    where object_id = :object_id
	}
    }

}

ad_returnredirect "object-audit-trail?object_id=$object_id&category_id=$category_id"
