ad_page_contract {
    /www/library/file-delete.tcl

    Ask the user for confirmation before deleting an attached document.

    @cvs-id $Id: file-delete.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    question_id:notnull,integer
    {parent_question_id:integer 0}
    {category_id ""}
    {return_page "one-question-edit"}
} -properties {
    title:onevalue
    client_filename:onevalue
    object_name:onevalue
    form_vars_proceed:onevalue
    form_vars_cancel:onevalue
    return_page:onevalue
}

set user_id [auth::require_login]
if ![km_check_object_id -check_edit_p 1 $object_id] { return }

set client_filename [db_string file_delete_10 "
    select content from sn_content
    where object_id=:object_id and question_id=:question_id"]

if [km_is_required -object_id $object_id $question_id] {
    ad_return_warning "Required Field" \
	"The attachment is mandatory and therefore may only be
	 overwritten, but not removed."
    return
}

set object_name [km_conn object_name]
set title "Delete Attached File"

set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data $title

set form_vars_proceed [export_form_vars object_id category_id question_id parent_question_id return_page]

if { $parent_question_id } {
    set question_id $parent_question_id
}
set form_vars_cancel [export_form_vars object_id category_id question_id]

ad_return_template
