ad_page_contract {
    /packages/library/www/admin/index.tcl

    @author Carsten Clasohm (carsten@arsdigita.com)
    @author Dirk Gomez (dirk@arsdigita.com)
    @author Jens Kordsmeier (jak@arsdigita.com)
    
    @cvs-id $Id: index.tcl,v 1.1 2003/07/02 12:19:42 peterm Exp $
} {
} -properties {
    context_bar:onevalue
    instance_name:onevalue
    object_types:multirow
    graphic_height:onevalue
    graphic_width:onevalue
    subsite_url:onevalue
    subsite_name:onevalue
    subcommunity_id:onevalue
    approval_p:onevalue
    publish_p:onevalue
    admin_p:onevalue
}

# connection timeout 
set user_id [ad_conn user_id]
set package_id [ad_conn package_id]
set instance_name [ad_conn instance_name] 

set return_uri [ad_urlencode "[ad_conn url]?[ad_conn query]"]
set have_alert [alerts::exists]

set admin_p [ad_permission_p $package_id "admin"]
set create_p [ad_permission_p $package_id "create"]
set publish_p [ad_permission_p $package_id "km_publish"]
set approval_p [km_static approval_p $package_id]

array set node [site_node_closest_ancestor_site_node "acs-subsite"]
set subsite_url $node(url)
set subsite_name $node(instance_name) 
set subcommunity_id $node(package_id) 

db_multirow object_types object_type {
    select object_type_id, pretty_name, pretty_plural, graphic,
           decode(create_p,'t',1,0) as create_p,
           decode(archive_p,'t',1,0) as archive_p,
           decode(copy_p,'t',1,0) as copy_p
    from sn_object_types
    where deleted_p = 'f'
	and browse_p = 't'
        and (public_p = 't' or :admin_p = 1)
        and context_id = :package_id
    order by sort_key, pretty_name
}

set title "Library Index"
set graphic_height [library_icon_height]
set graphic_width [library_icon_width]

set_context_bar_data

set cf(package_id) $package_id
portal_approval_processes [array get cf]

set search_contexts [list \
        [list "lib:$package_id" "$instance_name" ] \
        [list "sc:$subcommunity_id" "$subsite_name" ] \
                             [sws_km_site_search_context]]

ad_return_template
