# Displays the list of content-object links when existing_links is supplied as
# a list of lists in the order: table_name one_line_description

if {![info exists edit_p]} {
    set edit_p 0 
}

if {![info exists object_id]} {
    set object_id 0
}

if {![info exists category_id]} {
    set category_id ""
}

if {![info exists question_id]} {
    set question_id 0
}

# existing_links 

set return_url "[ns_conn url]?[ns_conn query]"

template::multirow create content_links i pretty_object delete_url_vars reason_url_vars link_comment
set i 1
foreach link $existing_links {
    set object_id_b [lindex $link 0]
    set one_line_description [lindex $link 1]
    set link_id [lindex $link 4]
    set object_id [lindex $link 5]
    set object_type [lindex $link 6]
    set presentation [lindex $link 7]
    set link_comment [lindex $link 10]
    set comment_html_p [lindex $link 11]

    if {![empty_string_p $link_comment]} {
        if {$comment_html_p} {
            set link_comment "([util_make_href_and_mailto_links $link_comment])"
        } else {
            set link_comment "([util_make_href_and_mailto_links [ad_quotehtml $link_comment]])"
        }
    }

    array unset od
    array set od [list name [sn_striphtml $one_line_description] presentation $presentation]

    template::multirow append content_links $i [sn_presentation::generic::linkable_item $object_type $object_id_b /o/$object_id_b od] [export_url_vars link_id question_id category_id object_id] [export_url_vars object_id link_id category_id return_url] $link_comment

    incr i
}
