# Returns three-part form elements for date entry: a select box for the month, 
# and two small text fields for day and year.

# named required parameters presentation_type question_id name


if {![info exists day_value]} {
    set day_value ""
}

if {![info exists month_value]} {
    set month_value ""
}

if {![info exists year_value]} {
    set year_value ""
}

util_unlist [month_list] months months_values

if {[string equal $presentation_type "select"]} {
    set days [list 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31]
    if ![info exists year_from] {
	util_unlist [km_get_year_range $question_id] year_from year_to
    }
    set years [list]
    for { set year $year_from } { $year <= $year_to } { incr year } {
        lappend years $year
    }
    if { $year_value < $year_from } {
        set years [concat $year_value $years]
    } elseif { $year_value > $year_to } {
        set years [concat $years $year_value]
    }
}

ad_return_template
