# Takes a list of child_object_data and displays the short_description and
# long description in a blue box.

if {![info exists edit_p]} {
    set edit_p 0 
}

if {![info exists category_id]} {
    set category_id ""
}

if {![info exists child_object_type]} {
    set child_object_type 0
}

if {![info exists question_state]} {
    set question_state "active"
}

# question_id user_id object_id children 


if !$child_object_type {
    set child_object_type [db_string km_display_child_object_1 "
    select target_object_type_id 
    from sn_questions where question_id=:question_id"]
}
set context_id [ad_conn package_id]

# We need the pretty name of the short and long descriptions:
db_1row question_info_long_desc {
    select nvl(q.question_id,0) as long_p, q.pretty_name as long_pretty_name
    from sn_questions q, sn_object_types ot
    where ot.long_description = q.question_id(+)
    and ot.object_type_id = :child_object_type 
    and ot.context_id = :context_id
}

set short_desc_list ""

db_foreach question_info_short_desc {
    select q1.pretty_name as short_pretty_name
    from sn_questions q1, sn_types_map_short_name map, sn_object_types ot
    where map.short_description = q1.question_id(+)
    and map.object_type_id = :child_object_type 
    and map.object_type_id = ot.object_type_id
    and ot.context_id = :context_id
    order by position
} {
    if {![empty_string_p $short_desc_list]} {
        append short_desc_list ",&nbsp;$short_pretty_name"
    } else {
        set short_desc_list $short_pretty_name
    }
}

if {![empty_string_p $short_desc_list]} {
    set short_p 1
} else {
    set short_p 0
}

set table ""

set i 1

template::multirow create children_list short_p long_p short_description public_p archived_p review_p edit_p question_state i url_vars long_description
foreach child $children {
    util_unlist $child object_id public_p archived_p review_p short_description long_description 
    
    if {[empty_string_p $short_description]} {
        set short_description [km_get_object_name $object_id]
    }
    set short_description [sn_striphtml $short_description]

    template::multirow append children_list $short_p $long_p $short_description $public_p $archived_p $review_p $edit_p $question_state $i [export_url_vars object_id category_id] $long_description
    incr i
}









