if {![info exists pretty_question]} {
    set pretty_question ""
}

if {![info exists value]} {
    set value ""
}

if {![info exists category_id]} {
    set category_id ""
}

if {![info exists edit_p]} {
    set edit_p 0
}

if {![info exists branch_p]} {
    set branch_p ""
}

if {![info exists root_branch_p]} {
    set root_branch_p ""
}

if {![info exists value_only_p]} {
    set value_only_p 0
}

set answered_p [km_answered_p $abstract_data_type $value]

if {$answered_p} {
    set user_id [ad_conn user_id]
    if {[empty_string_p $root_branch_p]} {
        set root_branch_p [km_root_branch_p $question_id]
    }
    
    if { [empty_string_p $branch_p] || $branch_p } {
        set object_type_id [km_conn object_type_id]
        set branch_parent [km_branch_parent $question_id $object_type_id]
    } else {
        set branch_parent ""
    }
    
    switch $abstract_data_type {
        "category" { 
            set category_value [km_display_category_value $value] 
        }
        "other_category" { 
            set category_value [km_display_other_category_value $value $object_id $question_id]
        }
        "option" { 
            set option_value [km_display_options $value] 
        }
        "date" { 
            set date_value [util_AnsiDatetoPrettyDate [fst $value]] 
        }
        "text" {
            set text_value [fst $value]
            if [empty_string_p $text_value] { return "" }

            set html_p [snd $value]

            if { [empty_string_p $html_p] || !$html_p == 1 } {
                set text_value [ad_text_to_html -- $text_value]
            } else {
                set text_value [ad_activate_hyperlinks $text_value]
	    }
        }
        "integer" { 
            set integer_value [fst $value] 
        }
    }

    if {($edit_p && ![km_conn archived_p]) || [km_conn admin_p]} {
        # The edit links on object-view.tcl are set according to abstract_data_type:
        if { $abstract_data_type == "object_link" } {
            set pretty_question "<a href=\"object-link?[export_url_vars object_id category_id question_id]\">[sn_striphtml $pretty_question]</a>"
        } else  {
            set pretty_question "<a href=\"one-question-edit?[export_url_vars object_id category_id question_id]\">[sn_striphtml $pretty_question]</a>"
        }
    } else {
        set pretty_question $pretty_question
    }

    if {![empty_string_p $branch_parent]} { 
        set pretty_question "... $pretty_question" 
    }
}
