# /www/library/link-delete-2.tcl
#
# Delete an object-object link.
#
# $Id: link-delete-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $

ad_page_variables {
    link_id
    return_url
}
csrf::authenticate

set user_id [auth::require_login]

# We are dealing with object <-> object links here. The following
# query relies on the originating object being referenced by the
# object_id_a column.

if {![db_0or1row link_delete_2_10 {
    select obj1.object_id as object_id_a, obj2.object_id as object_id_b, map.question_id
    from sn_links l, sn_objects obj1, sn_objects obj2, sn_question_link_map map
    where l.link_id=:link_id 
        and map.link_id = l.link_id
	and obj1.object_id = object_id_a
    and obj2.object_id = object_id_b}]} {
    # The link already has been deleted.
    ad_returnredirect $return_url
    return
}

# Check if the user is authorized to delete this link.

if ![km_check_object_id -check_edit_p 1 $object_id_a] { return }

db_transaction {

db_1row link_delete_2_20 "
select object_id as object_id_b, one_line_description as target_name, pretty_name as target_type
from sn_objects obj, sn_object_types ot
where object_id=:object_id_b
and obj.object_type_id = ot.object_type_id"

# All checks passed - let's delete the row.

db_dml link_delete_2_30 "delete from sn_links where link_id=:link_id"

db_dml link_delete_2_50 "
    insert into sn_audit_table 
    (object_id, question_id, last_modified, last_modifying_user_id, content)
    values ($object_id_a, $question_id, sysdate, $user_id, 
	'Deleted link to $target_type \"[DoubleApos $target_name]\"')"

db_dml link_delete_2_6 "
    update sn_objects 
    set last_modified = sysdate, last_modifying_user_id = $user_id
    [km_link_description_update $object_id_a $question_id]
    where object_id = $object_id_a"

}

ad_returnredirect $return_url
