ad_page_contract {
    link-reason-add.tcl

    After the user has selected or created an object for linking,
    ask him for the link comment.

    $Id: link-reason-add.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    path_id:notnull
}

set user_id [auth::require_login]

if ![path_valid_p $path_id] {
    ad_return_error "Invalid Path" \
	"The current path ID is invalid. Perhaps you used your browser's Back button
	 and tried to add another link?"
    return
}

set path_values [get_path_values -action_only_p 0 $path_id]
set original_object_id [value_from_tuples $path_values object_id]
set category_id [value_from_tuples $path_values category_id]

if ![km_check_object_id -check_edit_p 1 $original_object_id] { return }

set original_object_name [km_conn object_name]
set target_object_type [db_string get_object_type {
    select ot.pretty_name
    from sn_object_types ot, sn_objects o
    where o.object_id = :object_id
	and ot.object_type_id = o.object_type_id
}]

set title "Reason for linking to \"$original_object_name\""
set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Reason for linking"
set form_vars [export_form_vars object_id path_id link_id link_comment_id]
ad_return_template
