# /www/library/link-reason-edit-2.tcl
#
# Save the changed linking comment.
#
# $Id: link-reason-edit-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $

ad_page_variables {
    object_id
    link_id
    question_id
    link_comment
    html_p
    return_url
}
csrf::authenticate

set html_p [ad_decode $html_p 1 t f]
set user_id [auth::require_login]

# Check if the user is authorized to change this comment.
if ![km_check_object_id -check_edit_p 1 $object_id] { return }

set ip_address [ns_conn peeraddr]

db_transaction {

db_1row km_link_objects_20 "
  select one_line_description as target_name, pretty_name as target_type
  from sn_objects obj, sn_object_types ot
  where object_id=:object_id
  and obj.object_type_id = ot.object_type_id"

set content "Changed comment for link to $target_type \"[DoubleApos $target_name]\": $QQlink_comment"

db_dml link_reason_edit_10 {update sn_links set link_comment = :link_comment, html_p = :html_p where link_id =:link_id}
  
set ip_address [ns_conn peeraddr]
db_exec_plsql link_reason_edit_20 {
    begin
    object.audit_object (
    v_object_id              => :object_id,
    v_question_id            => :question_id,
    v_last_modifying_user_id => :user_id,
    v_modifying_ip           => :ip_address,
    v_content                => :content
    );
    end;
}

}

ad_returnredirect $return_url
