set user_id [auth::require_login]

ad_page_contract {
    Link with the news article.
} {
    source_id:integer,notnull
    pass:notnull
    target:integer,notnull
}

regexp {(\d*)} $pass match path_id

set values [get_path_values -action_only_p 0 $path_id]
set object_id [value_from_tuples $values object_id]
set category_id [value_from_tuples $values category_id]
set question_id [value_from_tuples $values question_id]

if ![km_check_object_id -check_edit_p 1 $object_id] { return }

set object_type_id [km_conn object_type_id]

set current_action [snd [get_path_values $path_id]]

if {[string equal $current_action add_sn_ref]} {
    ad_returnredirect "../add-sharenet-ref?path_id=$path_id&object_id=$target&category_id=$category_id&[csrf::link_token]"
}

set title "Link with Library object"
set_the_usual_klib_context_bar $object_id $category_id "../"
append_context_bar_data $title

set object_a_name [db_string link_object_a_name {
  select shortname
    from acs_objects_description
    where object_id = :source_id}]
set form_vars [export_form_vars source_id target pass]
ad_return_template
