ad_page_contract {
    /www/library/object-access-add-2.tcl

    Add a user to the access control list of a list of objects.

    @cvs-id $Id: object-access-add-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    linked_objects:integer,multiple,optional
    grantee_id:integer
    view_p:boolean,notnull
    edit_p:boolean,notnull
}
csrf::authenticate

set user_id [auth::require_login]
if ![km_check_object_id -check_edit_p 1 $object_id] { return }

if [info exists linked_objects] {
    db_transaction {

    foreach linked_object_id $linked_objects {
	if [km_check_object_id -check_edit_p 1 -print_errors_p 0 $linked_object_id] { 
	    if { $view_p } {
		db_exec_plsql grant_read {
		    begin
		    acs_permission.grant_permission(:linked_object_id, :grantee_id, 'read');
		    end;
		}
	    }

	    if { $edit_p } {
		db_exec_plsql grant_write {
		    begin
		    acs_permission.grant_permission(:linked_object_id, :grantee_id, 'write');
		    end;
		}
	    }
	}
    }

    }
}

ad_returnredirect "object-access?object_id=$object_id&category_id=$category_id"
