ad_page_contract {
    /packages/library/www/object-access-change.tcl

    Grant or revoke direct read/write permissions on an object.

    @cvs-id $Id: object-access-change.tcl,v 1.1 2003/07/02 12:19:43 peterm Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    party_ids:integer,multiple
    allow_edit:optional
    disallow_edit:optional
    disallow_access:optional
}
csrf::authenticate

if ![km_check_object_id -check_edit_p 1 $object_id] { return }

db_transaction {

if [info exists allow_edit] {
    foreach party_id $party_ids {
	db_exec_plsql grant_write {
	    begin
		acs_permission.grant_permission(:object_id, :party_id, 'write');
	    end;
	}
    }
} elseif [info exists disallow_edit] {
    foreach party_id $party_ids {
	db_exec_plsql grant_write {
	    begin
		acs_permission.revoke_permission(:object_id, :party_id, 'write');
	    end;
	}
    }
} elseif [info exists disallow_access] {
    foreach party_id $party_ids {
	db_exec_plsql grant_write {
	    begin
		acs_permission.revoke_permission(:object_id, :party_id, 'read');
		acs_permission.revoke_permission(:object_id, :party_id, 'write');
	    end;
	}
    }
}

}

ad_returnredirect "object-access?object_id=$object_id&category_id=$category_id"
