ad_page_contract {
    /packages/library/www/object-archive-2.tcl

    Actually put object (and descendants) into the Archive.
    If nephew is last public nephew, make uncle (and all descendants) private.

    @author Timo Hentschel (timo@arsdigita.com)
    @cvs-id $Id: object-archive-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    {return_url ""}
    cancel:optional
    confirm:optional
    {reason ""}
}
csrf::authenticate

set user_id [auth::require_login]
set package_id [ad_conn package_id]

if [empty_string_p $return_url] {
    set return_url "object-view?[export_url_vars object_id category_id]"
}

if {[info exists cancel]} {
    ad_returnredirect $return_url
    return
}

if {[empty_string_p $reason]} {
    ad_return_complaint 1 "You have to state a reason for archiving."
    return
}

if ![km_check_object_id -check_edit_p 1 $object_id] { return }

if {[km_conn archived_p]} {
    ad_returnredirect $return_url
}

set object_type_id [km_conn object_type_id]
set archive_p [km_static object_type_archive_p $object_type_id]
set publish_p [km_conn publish_p]
set admin_p [km_conn admin_p]
set public_p [km_conn public_p]
set in_review_p [km_conn in_review_p]
set approval_p [km_static approval_p $package_id]

if {!$archive_p || ($approval_p && !$publish_p && !$admin_p && ($public_p || $in_review_p))} {
    ad_return_complaint 1 "Not allowed to archive [km_static object_type_pretty_plural $object_type_id]!"
    return
}

set nephew_p [km_is_mandatory_nephew_p $object_id]

db_transaction {

    km_object_archive $object_id $reason

    db_dml insert_reason {
	insert into sn_object_archive_reasons
	(object_id, reason_for_archiving, archived_on)
	values
	(:object_id, :reason, sysdate)
    }

    if {$nephew_p} {
	set uncle [km_get_uncle $object_id]
	set uncle_id [fst $uncle]
	if { [km_uncle_needs_private_status_p $uncle_id] } {
	    km_object_unpublish $uncle_id
	}
    }

}

km_flush_category_count -object_type_id $object_type_id

ad_returnredirect $return_url
