ad_page_contract {
    /packages/library/www/object-archive.tcl

    Put an object in the Archive.

    @author Timo Hentschel (timo@arsdigita.com)
    @cvs-id $Id: object-archive.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    {return_url ""}
} -properties {
    title:onevalue
    form_vars:onevalue
    dc_export:onevalue
    uncle_id:onevalue
    uncle_name:onevalue
    uncle_p:onevalue
    nephew_p:onevalue
    object_type:onevalue
    uncle_object_type:onevalue
    descendent_object_types:onevalue
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]
if ![km_check_object_id -check_edit_p 1 $object_id] { return }

if {[km_conn archived_p]} {
    ad_returnredirect $return_url
    return
}

set object_type_id [km_conn object_type_id]
set archive_p [km_static object_type_archive_p $object_type_id]
set publish_p [km_conn publish_p]
set admin_p [km_conn admin_p]
set public_p [km_conn public_p]
set in_review_p [km_conn in_review_p]
set approval_p [km_static approval_p $package_id]

if {!$archive_p || ($approval_p && !$publish_p && !$admin_p && ($public_p || $in_review_p))} {
    ad_return_complaint 1 "Not allowed to archive [km_static object_type_pretty_plural $object_type_id]!"
    return
}

set object_type [km_static object_type_pretty_name $object_type_id]
set object_name [km_conn object_name]
set nephew_p [km_is_mandatory_nephew_p $object_id]
set uncle_p [km_is_uncle_p $object_id]
set parent_p [km_is_parent_p $object_id]
set uncle_object_type ""
set descendent_object_types ""

if {$nephew_p} {
    set uncle [km_get_uncle $object_id]
    set uncle_id [fst $uncle]
    set uncle_name [snd $uncle]
    set uncle_object_type [km_static object_type_pretty_name [thd $uncle]]
    set ancestor_id $uncle_id
}

if {$uncle_p || $parent_p} {
    set ancestor_id $object_id
}

if {$uncle_p || $parent_p || $nephew_p} {
    db_foreach get_descendent_object_type_list {
	select q.target_object_type_id as descendent_object_type_id
        from sn_questions q, sn_question_object_type_map qm, sn_objects o
        where q.question_id = qm.question_id
            and qm.question_state = 'active' 
	    and qm.object_type_id = o.object_type_id
            and o.object_id = :ancestor_id
            and o.context_id=:package_id
	    and q.abstract_data_type in ('nephew_object','child_object')
    } {
	lappend object_type_list [km_static object_type_pretty_plural $descendent_object_type_id]
    }
    set descendent_object_types [join $object_type_list " and "]
}

set title "Archive $object_type '$object_name'"
set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Archive"
set form_vars [export_form_vars object_id category_id return_url]
set dc_export [doubleclick::signature_html]

ad_return_template
