ad_page_contract {
    /packages/library/www/object-audit-trail.tcl

    Object access history.

    @cvs-id $Id: object-audit-trail.tcl,v 1.1 2003/07/02 12:19:43 peterm Exp $
} {
    object_id:notnull,integer
    {category_id ""}
} -properties {
    title:onevalue
    admin_p:onevalue
    history:multirow
    object_id:onevalue
}

set user_id [ad_conn user_id]
if ![km_check_object_id $object_id] { return }

set admin_p [km_conn admin_p]
set object_name [km_conn object_name]
set title "History"
set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "History"

# Get the entries in the audit table

set old_selection [ns_set create old_selection]
template::multirow create history question_id question_name content new_p rowid name modified_date modified_time user_link

db_foreach object_audit_trail_10 {
    select a.rowid, a.question_id, a.content, obj.one_line_description as name,
	first_names || ' ' || last_name as modifying_user_name, 
	a.last_modifying_user_id as modifying_user_id, a.last_modified,
	to_char(a.last_modified,'HH24:MI') as modified_time
    from sn_audit_table a, sn_objects obj, users u
    where u.user_id (+) = a.last_modifying_user_id
	and a.object_id = :object_id
	and obj.object_id = :object_id 
	and a.content is not null
    order by a.last_modified asc
} {
    set modified_date [util_AnsiDatetoPrettyDate $last_modified]
    if { $content != [ns_set get $old_selection $question_id] || [empty_string_p $question_id] } {
	# report if the value changed
	if { [empty_string_p $question_id] } {
	    set new_p 2
	    set question_name ""
	} else {
	    set question_name [km_static question_pretty_name $question_id]
	    if { [empty_string_p [ns_set get $old_selection $question_id]]} { 
		set new_p 1
	    } else {
		set new_p 0
	    }
	}
	if ![empty_string_p $modifying_user_id] {
	    set user_link [ad_present_user $modifying_user_id $modifying_user_name]
	} else {
	    set user_link ""
	}
	template::multirow append history $question_id $question_name $content $new_p $rowid $name $modified_date $modified_time $user_link
    }

    if ![empty_string_p $question_id] {
	ns_set update $old_selection $question_id $content
    }
}
 
ad_return_template
