ad_page_contract {
    object-copy-1.tcl

    Present user a list of descendant object which he might want to copy, too.
    We came from index, browse-one-* or object-view

    @author Timo Hentschel (timo@arsdigita.com)
    $Id: object-copy-1.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    {object_type_id:integer ""}
    {category_id ""}
    {path_id:integer ""}
    {copy_id:integer ""}
    {object_id:integer ""}
    {return_url ""}
    cancel:optional
    copy:optional
} -properties {
    title:onevalue
    form_vars:onevalue
    descendants:multirow
    object_type:onevalue
    object_type_plural:onevalue
    object_name:onevalue
    object_id:onevalue
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]

if ![empty_string_p $copy_id] {
    set object_id $copy_id
}

if {[info exists cancel]} {
    set return_url "browse-one-type?[export_url_vars object_type_id]"
    ad_returnredirect $return_url
    return
}

if {[empty_string_p $object_type_id] && [empty_string_p $object_id]} {
    ad_return_complaint 1 "Please select an object that should be copied!"
    return
}

## check if object can be copied - correct permissions
if ![km_check_object_id $object_id] { return }
if {![km_conn admin_p] && ![km_conn write_p]} { return }
set object_type_id [km_conn object_type_id]
set object_name [km_conn object_name]

set object_type [km_static object_type_pretty_name $object_type_id]
set object_type_plural [km_static object_type_pretty_plural $object_type_id]
set title "Copy linked objects"
set new_object_id [km_new_acs_object_id]
set form_vars [export_vars -form {object_type_id category_id path_id copy_id object_id return_url}]
set url_vars [export_url_vars object_type_id category_id path_id]

if {![km_static object_type_copy_p $object_type_id]} {
    ad_return_complaint 1 "Not allowed to copy $object_type_plural!"
    return
}

if {![km_static object_type_create_p $object_type_id]} {
    ad_return_complaint 1 "No standalone objects allowed for $object_type_plural!"
    return
}

if {[empty_string_p $copy_id]} {
    ## so we are called from object-view
    set_the_usual_klib_context_bar $object_id $category_id
    append_context_bar_data "Copy"

} else {
    ## so we are called from index, browse-one-type or browse-one-category
    set_context_bar_data [list "browse-one-type?[export_url_vars object_type_id]" $object_type_plural] [list "object-copy?$url_vars" "Copy a $object_type"] $title
}

set count 0
template::multirow create descendants child_id child_name child_type_id child_type_plural public_p archived_p review_p
db_foreach get_object_descendants {
    select obj.object_id as child_id, obj.one_line_description as child_name,
    obj.object_type_id as child_type_id,
    acs_permission.permission_p(obj.object_id, :user_id, 'write') as write_p,
    decode(obj.public_p,'t',1,0) as public_p,
    decode(obj.archived_p,'t',1,0) as archived_p,
    decode(obj.in_review_p,'t',1,0) as review_p
    from sn_objects obj, km_flat_object_hierarchy fo
    where fo.parent = :object_id
    and fo.distance = 1
    and obj.object_id = fo.child
    and obj.expiration_date > sysdate
    order by obj.object_type_id, obj.one_line_description
} {
    if {$write_p == "t"} {
	if [empty_string_p $child_name] {
	    set child_name "Unnamed [km_static object_type_pretty_name $child_type_id]"
	}
	template::multirow append descendants $child_id $child_name $child_type_id [km_static object_type_pretty_plural $child_type_id] $public_p $archived_p $review_p
    }
    incr count
}

if {$count == 0} {
    ad_returnredirect "object-copy-2?[export_url_vars object_type_id category_id path_id copy_id object_id return_url]"
    return
}

ad_return_template
