ad_page_contract {
    packages/library/www/object-delete.tcl

    Ask the user for confirmation before deleting an object.

    @cvs-id $Id: object-delete.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    {question_id:integer 0}
    {parent_object_id:integer 0}
    {uncle_object_id:integer 0}
    {return_delete ""}
    {return_cancel ""}
} -properties {
    title:onevalue
    form_vars_delete:onevalue
    form_vars_cancel:onevalue
    parent_object_id:onevalue
    object_name:onevalue
    object_type:onevalue
    second_object_type:onevalue
    return_cancel:onevalue
    uncle_p:onevalue
    nephew_p:onevalue
    private_uncle_needed_p:onevalue
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]
if ![km_check_object_id -check_delete_p 1 $object_id] { return }

set object_name [km_conn object_name]
set object_type_id [km_conn object_type_id]
set uncle_p [km_is_uncle_p $object_id]
set nephew_p [km_is_nephew_with_private_uncle_p $object_id "t"]
set object_type [km_static object_type_pretty_name $object_type_id]
set private_uncle_needed_p 0

if { $parent_object_id && $parent_object_id != [fst [km_get_parent $object_id]] } {
    ad_return_complaint 1 "The parent object given doesn't match the parent in the database."
    return
}

if { $uncle_object_id && $uncle_object_id != [fst [km_get_uncle $object_id]] } {
    ad_return_complaint 1 "The uncle object given doesn't match the uncle in the database."
    return
}

if { [empty_string_p $return_delete] && [empty_string_p $return_cancel] && $question_id && ($parent_object_id || $uncle_object_id) } {
    # We're deleting a child or nephew object
    set return_delete "one-question-edit"
    set return_cancel "one-question-edit"
} 

if {[empty_string_p $return_delete]} {
    set return_delete "browse-one-type"
}
if {[empty_string_p $return_cancel]} {
    set return_cancel "object-view"
}

set title "Delete Object"
set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data $title

set dc_signature [doubleclick::signature]
set form_vars_delete [export_form_vars object_id category_id parent_object_id uncle_object_id question_id return_delete object_type_id dc_signature]

if {$uncle_p} {
    db_foreach get_nephew_object_type_list {
	select q.target_object_type_id as nephew_object_type_id
        from sn_questions q, sn_question_object_type_map qm, sn_objects o
        where q.question_id = qm.question_id
            and qm.question_state = 'active' 
	    and qm.object_type_id = o.object_type_id
            and o.object_id = :object_id
            and o.context_id=:package_id
	    and q.abstract_data_type = 'nephew_object'
    } {
	lappend object_type_list [km_static object_type_pretty_plural $nephew_object_type_id]
    }
    set second_object_type [join $object_type_list " and "]
} elseif {$nephew_p} {
    set uncle [km_get_uncle $object_id]
    set second_object_type [km_static object_type_pretty_name [thd $uncle]]
    set private_uncle_needed_p [km_uncle_needs_private_status_p [fst $uncle] $object_id]
} else {
    set second_object_type ""
}

if { $question_id && $parent_object_id } {
    set object_id $parent_object_id
}
if { $question_id && $uncle_object_id } {
    set object_id $uncle_object_id
}

set form_vars_cancel [export_form_vars object_id category_id question_id]

ad_return_template
