ad_page_contract {
    /www/library/object-deleted.tcl

    Tell the user that this object has been deleted.

    @cvs-id $Id: object-deleted.tcl,v 1.1 2003/07/02 12:19:43 peterm Exp $
} {
    object_id:notnull,integer
} -properties {
    pretty_type:onevalue
    object_name:onevalue
    expiration_date:onevalue
    deletor_link:onevalue
    title:onevalue
    reason_for_deleting:onevalue
}

if ![km_check_object_id -check_deleted_p 0 $object_id] { return }

set object_name [km_conn object_name]
set pretty_type [km_static object_type_pretty_name [km_conn object_type_id]]
set expiration_date [km_conn expiration_date]
set last_modifying_user_id [km_conn last_modifying_user_id]

if [empty_string_p $object_name] {
    set object_name "Unnamed $pretty_type"
}

db_1row deletor_info {
    select u.first_names || ' ' || u.last_name as deletor_name
    from users u
    where u.user_id = :last_modifying_user_id
}

set reason_for_deleting [db_string reason_for_deleting {
    select reason_for_deleting
    from sn_object_delete_reasons
    where object_id = :object_id
} -default ""]

set expiration_date [util_AnsiDatetoPrettyDate $expiration_date]
set deletor_link [ad_present_user $last_modifying_user_id $deletor_name]

set_the_usual_klib_context_bar $object_id
append_context_bar_data "Object Deleted"

set title "Object Deleted"

ad_return_template
