# /www/library/object-link.tcl
#
# Show existing links for an object and allow the user to add new
# links.
#
# $Id: object-link.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $

ad_page_variables {
    object_id
    question_id
    {category_id ""}
    {path_id ""}
}

set user_id [auth::require_login]
if ![km_check_object_id $object_id] { return }

set object_name [km_conn object_name]
set object_type_id [km_conn object_type_id]
set pretty_type [km_static object_type_pretty_name $object_type_id]
set pretty_type_plural [km_static object_type_pretty_plural $object_type_id]
set graphic [km_static object_type_graphic $object_type_id]

set path_vars [set_path_values -question_id $question_id $object_id $category_id]
set return_url "object-link?[export_url_vars object_id category_id question_id path_id]"
set new_path_id [init_path -last_path_id $path_id $path_vars $return_url link]

set question_list [list $question_id] 

set question_info [km_get_question $question_id $object_type_id]
set question_state [lindex $question_info 3]

if {$question_state != "active" } {
    # If there are no links and the question is not active,
    # there's no point in being here.
    ad_returnredirect "questions?[export_url_vars object_id category_id]"
    return
}

# Check if the question still exists and inform the user about the
# current state.
if [null_p $question_info] {
    ad_return_warning "Question does not exist." "
	The question with id $question_id is not accessible, probably
	because it has been made invisible."
    return
}

set title "$pretty_type_plural: Add a link to $object_name"
set graphic_width [library_icon_width]

set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Add a link"
set form_vars [export_form_vars question_id object_id category_id object_type_id path_id]
set buttons [km8_button_panel $question_id $object_id $object_type_id]
set button_1 [lindex $buttons 0]
set button_2 [lindex $buttons 1]
set button_3 [lindex $buttons 2]
set button_4 [lindex $buttons 3]
set button_5 [lindex $buttons 4]

ad_return_template

