ad_page_contract {
    /packages/library/www/object-unarchive-2.tcl

    Actually remove object (and descendants) from the Archive. If nephew
    is last archived public nephew, make uncle (and all descendants) private.

    @author Timo Hentschel (timo@arsdigita.com)
    @cvs-id $Id: object-unarchive-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    {return_url ""}
    cancel:optional
    confirm:optional
    copy:optional
    {object_id_list:multiple,integer ""}
}
csrf::authenticate

set user_id [auth::require_login]

if [empty_string_p $return_url] {
    set return_url "object-view?[export_url_vars object_id category_id]"
}

if {[info exists cancel]} {
    ad_returnredirect $return_url
    return
}

if ![km_check_object_id $object_id] { return }

if {![km_conn archived_p]} {
    ad_returnredirect $return_url
    return
}

if {![km_conn admin_p] && ![km_conn write_p]} { return }
    
set object_type_id [km_conn object_type_id]

if {[info exists copy]} {
    if {![km_static object_type_copy_p $object_type_id] || ![km_static object_type_create_p $object_type_id]} {
	ad_returnredirect $return_url
	return
    } else {
	ad_returnredirect "object-copy-2?[export_vars -url {object_id category_id object_id_list:multiple return_url}]"
	return
    }
}

if [empty_string_p $object_id_list] {
    set object_id_list [list]
}

set object_type_id [km_conn object_type_id]
set nephew_p [km_is_mandatory_nephew_p $object_id]

if {[km_archived_ancestor_p $object_id]} {
    set ancestor [fst [reverse [km_get_object_ancestors $object_id]]]
    set ancestor_id [fst $ancestor]
    set ancestor_name [snd $ancestor]
    set ancestor_type [km_static object_type_pretty_name [thd $ancestor]]
    ad_return_complaint 1 "This $object_type '$object_name' can't be removed from the archive since the linked $ancestor_type <a href=\"object-view?object_id=$ancestor_id&category_id=$category_id\">$ancestor_name</a> needs to be removed from the archive first."
    return
}

db_transaction {

    km_object_unarchive $object_id $object_id_list

    if {$nephew_p} {
	set uncle [km_get_uncle $object_id]
	set uncle_id [fst $uncle]
	if { [km_uncle_needs_private_status_p $uncle_id] } {
	    km_object_unpublish $uncle_id
	}
    }

}

km_flush_category_count -object_type_id $object_type_id

ad_returnredirect $return_url
