ad_page_contract {
    /packages/library/www/object-unarchive.tcl

    Remove an object from the Archive.

    @author Timo Hentschel (timo@arsdigita.com)
    @cvs-id $Id: object-unarchive.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    {return_url ""}
} -properties {
    title:onevalue
    form_vars:onevalue
    dc_export:onevalue
    uncle_id:onevalue
    uncle_name:onevalue
    uncle_p:onevalue
    public_p:onevalue
    nephew_p:onevalue
    object_type:onevalue
    uncle_object_type:onevalue
    descendent_object_types:onevalue
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]
if ![km_check_object_id $object_id] { return }

if {![km_conn archived_p]} {
    ad_returnredirect $return_url
    return
}

if {![km_conn admin_p] && ![km_conn write_p]} { return }

set object_type_id [km_conn object_type_id]
set object_type [km_static object_type_pretty_name $object_type_id]
set object_name [km_conn object_name]
set public_p [km_conn public_p]
set nephew_p [km_is_mandatory_nephew_p $object_id]
set uncle_p [km_is_uncle_p $object_id]
set parent_p [km_is_parent_p $object_id]
set copy_p [km_static object_type_copy_p $object_type_id]
set create_p [km_static object_type_create_p $object_type_id]
set uncle_object_type ""
set descendent_object_types ""
set archived_ancestor_p [km_archived_ancestor_p $object_id]

if {$copy_p} {
    set copy_p $create_p
}

if {$archived_ancestor_p} {
    set ancestor [fst [reverse [km_get_object_ancestors $object_id]]]
    set ancestor_id [fst $ancestor]
    set ancestor_name [snd $ancestor]
    set ancestor_type [km_static object_type_pretty_name [thd $ancestor]]
}

if {$nephew_p && $public_p} {
    set uncle [km_get_uncle $object_id]
    set uncle_id [fst $uncle]
    set uncle_name [snd $uncle]
    set uncle_object_type [km_static object_type_pretty_name [thd $uncle]]
    db_foreach get_descendent_object_type_list {
	select q.target_object_type_id as descendent_object_type_id
        from sn_questions q, sn_question_object_type_map qm, sn_objects o
        where q.question_id = qm.question_id
            and qm.question_state = 'active' 
	    and qm.object_type_id = o.object_type_id
            and o.object_id = :uncle_id
            and o.context_id=:package_id
	    and q.abstract_data_type in ('nephew_object','child_object')
    } {
	lappend object_type_list [km_static object_type_pretty_plural $descendent_object_type_id]
    }
    set descendent_object_types [join $object_type_list " and "]
}

if {$uncle_p || $parent_p} {
    template::multirow create descendants child_id child_name child_type_id child_type_plural
    db_foreach get_object_descendants {
	select obj.object_id as child_id, obj.one_line_description as child_name,
               obj.object_type_id as child_type_id
	from sn_objects obj, km_flat_object_hierarchy fo
        where fo.parent = :object_id
	and fo.distance = 1
	and obj.object_id = fo.child
	and obj.archived_p = 't'
	and obj.expiration_date > sysdate
	order by obj.object_type_id, obj.one_line_description
    } {
	if [empty_string_p $child_name] {
	    set child_name "Unnamed [km_static object_type_pretty_name $child_type_id]"
	}
	template::multirow append descendants $child_id $child_name $child_type_id [km_static object_type_pretty_plural $child_type_id]
    }
}

set title "Remove $object_type '$object_name' from Archive"
set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Remove from Archive"
set form_vars [export_form_vars object_id category_id return_url]
set dc_export [doubleclick::signature_html]

ad_return_template
