ad_page_contract {
    /packages/library/www/object-unpublish-2.tcl

    Mark a nephew or uncle object as private.

    @cvs-id $Id: object-unpublish-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    {return_url ""}
    cancel:optional
    confirm:optional
}
csrf::authenticate

set user_id [auth::require_login]
set package_id [ad_conn package_id]

if [empty_string_p $return_url] {
    set return_url "object-view?[export_url_vars object_id category_id]"
}

if {[info exists cancel]} {
    ad_returnredirect $return_url
    return
}

if ![km_check_object_id $object_id] { return }

if {![km_conn public_p]} {
    ad_returnredirect $return_url
}

set author_id [km_conn original_author_id]
set write_p [km_conn write_p]
set admin_p [km_conn admin_p]
set archived_p [km_conn archived_p]
set publish_p [km_conn publish_p]
set approval_p [km_static approval_p $package_id]

if { !$admin_p && (!$write_p || $archived_p || ($approval_p && !$publish_p)) } { return }

set nephew_p [km_is_mandatory_nephew_p $object_id]
set child_p [km_is_child_p $object_id]

if {$child_p} {
    set object_type [km_static object_type_pretty_name [km_conn object_type_id]]
    set parent_object_type [km_static object_type_pretty_name [thd [km_get_parent $object_id]]]
    ad_return_complaint 1 "Not allowed to unpublish this $object_type separately from the linked $parent_object_type."
    return
}

db_transaction {

    km_object_unpublish $object_id

    if {$nephew_p} {
	set uncle [km_get_uncle $object_id]
	set uncle_id [fst $uncle]
	set uncle_name [snd $uncle]
	if { [km_uncle_needs_private_status_p $uncle_id] } {
	    km_object_unpublish $uncle_id
	}
    }

}

ad_returnredirect $return_url
