ad_page_contract {
    /packages/library/www/object-unpublish.tcl

    Mark an object as private.

    @cvs-id $Id: object-unpublish.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    {return_url ""}
} -properties {
    title:onevalue
    form_vars:onevalue
    dc_export:onevalue
    uncle_id:onevalue
    uncle_name:onevalue
    uncle_p:onevalue
    nephew_p:onevalue
    object_type:onevalue
    uncle_object_type:onevalue
    descendent_object_types:onevalue
}
csrf::authenticate
set user_id [auth::require_login]
set package_id [ad_conn package_id]
if ![km_check_object_id $object_id] { return }

if ![km_conn public_p] {
    ad_returnredirect $return_url
    return
}

set author_id [km_conn original_author_id]
set write_p [km_conn write_p]
set admin_p [km_conn admin_p]
set archived_p [km_conn archived_p]
set publish_p [km_conn publish_p]
set approval_p [km_static approval_p $package_id]

if { !$admin_p && (!$write_p || $archived_p || ($approval_p && !$publish_p)) } { return }

set object_type [km_static object_type_pretty_name [km_conn object_type_id]]
set nephew_p [km_is_mandatory_nephew_p $object_id]
set child_p [km_is_child_p $object_id]
set uncle_p [km_is_uncle_p $object_id]
set parent_p [km_is_parent_p $object_id]
set uncle_object_type ""
set descendent_object_types ""

if {$child_p} {
    set parent_object_type [km_static object_type_pretty_name [thd [km_get_parent $object_id]]]
    ad_return_complaint 1 "Not allowed to unpublish this $object_type separately from the linked $parent_object_type."
    return
}

if {$nephew_p} {
    set uncle [km_get_uncle $object_id]
    set uncle_id [fst $uncle]
    set uncle_name [snd $uncle]
    set uncle_object_type [km_static object_type_pretty_name [thd $uncle]]
    db_foreach get_descendent_object_type_list {
	select q.target_object_type_id as descendent_object_type_id
        from sn_questions q, sn_question_object_type_map qm, sn_objects o
        where q.question_id = qm.question_id
            and qm.question_state = 'active' 
	    and qm.object_type_id = o.object_type_id
            and o.object_id = :uncle_id
            and o.context_id=:package_id
	    and q.abstract_data_type in ('nephew_object','child_object')
    } {
	lappend object_type_list [km_static object_type_pretty_plural $descendent_object_type_id]
    }
    set descendent_object_types [join $object_type_list " and "]
}

if {$uncle_p || $parent_p} {
    db_foreach get_descendent_object_type_list {
	select q.target_object_type_id as descendent_object_type_id
        from sn_questions q, sn_question_object_type_map qm, sn_objects o
        where q.question_id = qm.question_id
            and qm.question_state = 'active' 
	    and qm.object_type_id = o.object_type_id
            and o.object_id = :object_id
            and o.context_id=:package_id
	    and q.abstract_data_type in ('nephew_object','child_object')
    } {
	lappend object_type_list [km_static object_type_pretty_plural $descendent_object_type_id]
    }
    set descendent_object_types [join $object_type_list " and "]
}

if {$parent_p || $uncle_p || ($nephew_p && [km_uncle_needs_private_status_p $uncle_id $object_id])} {
    set title "Unpublish linked objects"
    set_the_usual_klib_context_bar $object_id $category_id
    append_context_bar_data "Make private"
    set form_vars [export_form_vars object_id category_id return_url]
    set dc_export [doubleclick::signature_html]
} else {
    km_object_unpublish $object_id

    if [empty_string_p $return_url] {
	set return_url "object-view?[export_url_vars object_id category_id]"
    }

    ad_returnredirect $return_url
    return
}

ad_return_template
