ad_page_contract {
    Show all objects linked to the given object.
    $Id: object-view-linked.tcl,v 1.1 2003/07/02 12:19:43 peterm Exp $
} {
    object_id:integer,notnull
    {category_id ""}
} -properties {
    object_id:onevalue
    community_id:onevalue
    admin_p:onevalue
    public_p:onevalue
    original_author_id:onevalue
    user_id:onevalue
    child_p:onevalue
    archived_p:onevalue
    review_p:onevalue
}

set user_id [ad_conn user_id]
if {![km_check_object_id $object_id]} { return }

set object_name [km_conn object_name]
set object_type_id [km_conn object_type_id]
set pretty_type [km_static object_type_pretty_name $object_type_id]
set pretty_type_plural [km_static object_type_pretty_plural $object_type_id]
set title "[km_static object_type_pretty_name $object_type_id]: $object_name"

array set node [site_node_closest_ancestor_site_node "acs-subsite"] 
set community_id $node(package_id) 
set public_p [km_conn public_p]
set archived_p [km_conn archived_p]
set review_p [km_conn review_p]
set original_author_id [km_conn original_author_id]

# Determine which permissions the viewing user has.
set admin_p [km_conn admin_p]

set linked_objects [km_get_linked_objects -to_p 1 -from_p 1 $user_id $object_id]
set length_linked_objects [llength $linked_objects]

set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Linked Objects"
set child_p [km_is_descendant_p $object_id]

ad_return_template
