# Allow the user to select different views of the object if he
# is allowed to edit the object:
  
# All Questions | Unanswered Questions | Linked Objects | Completed Content | Indexed Content | XML


if ![info exists child_p] {
    set child_p 0
}

if ![info exists subsite_url] {
    array set node [site_node_closest_ancestor_site_node "acs-subsite"] 
    set subsite_url $node(url)
}

set bar_pretty {}
set bar_url {}
set bar_short {}

set parameters [export_url_vars object_id category_id]
set write_p [km_conn write_p]
set admin_p [km_conn admin_p]
set archived_p [km_conn archived_p]
if {$archived_p} {
    set write_p $admin_p
}

set csrf_link [csrf::link_token]

if {[info exists bookmarks::initialized]} {
    set bookmarks_installed_p 1
    set viewer_id [ad_conn user_id]
    upvar bookmarked_p bookmarked shopping_cart_p shopping_cart
    set bookmarked [bookmarks::is_bookmarked $viewer_id $object_id]
    set shopping_cart [bookmarks::in_the_shopping_cart $viewer_id $object_id]
    set return_uri [ad_urlencode "[ad_conn url]?object_id=$object_id&category_id=$category_id"]
    if {!$bookmarked} {
        set node_id [ad_conn node_id]
        db_0or1row get_community_id {
            select c.community_id
            from site_nodes s, site_nodes sp, sn_communities c
            where s.node_id = :node_id
            and s.parent_id = sp.node_id
            and sp.object_id = c.community_id
        }   
        set bookmark_url_vars [export_url_vars community_id object_id]
    }
} else {
    set bookmarks_installed_p 0
}

if {$archived_p} {
    set have_alert 1
} else {
    set have_alert [alerts::exists -object_id $object_id -content_type_id [km_conn object_type_id]]
}

