ad_page_contract {
    /www/library/one-question-edit.tcl

    Create the form for editing one question.

    @cvs-id $Id: one-question-edit.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    {object_id:integer ""}
    {question_id:integer ""}
    {category_id ""}
    path_id:integer,optional
} -properties {
    title:onevalue
    form_vars:onevalue
    graphic:onevalue
    graphic_width:onevalue
    ancestor_object_id:onevalue
    user_id:onevalue
    question_list:onevalue
    object_id:onevalue
    object_type_id:onevalue
}

if { [info exists path_id] && [empty_string_p $question_id] } {
    # Get the path variables.
    set values [get_path_values -action_only_p 0 $path_id]
    set object_id [value_from_tuples $values object_id] 
    set question_id [value_from_tuples $values question_id]
}

set user_id [auth::require_login]
if ![km_check_object_id -check_edit_p 1 $object_id] { return }

set object_name [km_conn object_name]
set object_type_id [km_conn object_type_id]
set pretty_type [km_static object_type_pretty_name $object_type_id]
set pretty_type_plural [km_static object_type_pretty_plural $object_type_id]
set graphic [km_static object_type_graphic $object_type_id]
set graphic_width [library_icon_width]
set archived_p [km_conn archived_p]
set admin_p [km_conn admin_p]
set all_types_p 0
if {$admin_p && $archived_p} {
    set all_types_p 1
}

set question_info [km_get_question -all_types_p $all_types_p $question_id $object_type_id]

if [null_p $question_info] {
    ad_return_warning "Invalid Question ID" "
	The given question does not exist, probably because it has been removed
	from this object type. Please go back to the 
	<a href=\"questions?[export_url_vars object_id category_id]\">list of questions</a>."
    return
}

set abstract_data_type [thd $question_info]
set question_state [lindex $question_info 3]

set composite_parent_id [km_composite_parent $question_id $object_type_id]
if ![empty_string_p $composite_parent_id] {
    ad_returnredirect "one-question-edit?[export_url_vars object_id category_id path_id]&question_id=$composite_parent_id"
    return
}

set ancestor_object_id [fst [fst [km_get_object_ancestors $object_id]]]

set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Edit"

set abstract_data_type [km_static question_abstract_data_type $question_id]

if {[string equal $abstract_data_type "child_object"] || [string equal $abstract_data_type "nephew_object"]} {
    db_1row check_if_answered {
	select count(*) as answers
	from sn_question_link_map map, sn_links l
	where map.question_id = :question_id
	and map.link_id = l.link_id
	and l.object_id_a = :object_id
    }
    if {!$answers && ![km_static object_type_copy_p [km_static question_target_object_type_id $question_id]]} {
	if {[string equal $abstract_data_type "child_object"]} {
	    ad_returnredirect "one-question-edit-2?[export_url_vars question_id object_id category_id path_id object_type_id]&add_child.$question_id"
	    return
	}
	if {[string equal $abstract_data_type "nephew_object"]} {
	    ad_returnredirect "one-question-edit-2?[export_url_vars question_id object_id category_id path_id object_type_id]&add_nephew.$question_id"
	    return
	}
    }
}

set title "$pretty_type: Edit $object_name"
set form_vars [export_form_vars question_id object_id category_id path_id object_type_id parent_object_id uncle_object_id]

set question_list [list $question_id]

set buttons [km8_button_panel $question_id $object_id $object_type_id]

set button_1 [lindex $buttons 0]
set button_2 [lindex $buttons 1]
set button_3 [lindex $buttons 2]
set button_4 [lindex $buttons 3]
set button_5 [lindex $buttons 4]


ad_return_template
