ad_page_contract {
    /packages/library/www/owner-change-2.tcl

    Change the ownership of an object.

    @cvs-id $Id: owner-change-2.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    user_id_from_search:notnull,integer
    {still_access_p:boolean "f"}
    {reason ""}
    {page_url:notnull}
}
csrf::authenticate

set user_id [auth::require_login]
if {![km_check_object_id $object_id]} { return }
if ![km_check_owner_change $object_id] { return }

set author_id [km_conn original_author_id]

# Everything seems fine. Now we can put the old owner on the access list.

db_transaction {

    if { $still_access_p == "f" } {
	# Revoke permissions for old owner.
	db_exec_plsql revoke_old_owner {
	    begin
	    acs_permission.revoke_permission(:object_id, :author_id, 'read');
	    acs_permission.revoke_permission(:object_id, :author_id, 'write');
	    acs_permission.revoke_permission(:object_id, :author_id, 'delete');
	    end;
	}
    }

    # Grant permissions to the new owner.
    db_exec_plsql grant_new_owner {
	begin
	acs_permission.grant_permission(:object_id, :user_id_from_search, 'read');
	acs_permission.grant_permission(:object_id, :user_id_from_search, 'write');
	acs_permission.grant_permission(:object_id, :user_id_from_search, 'delete');
	end;
    }

    # And now we update the owner
    db_dml update_owner {
	update sn_objects
	set original_author_id = :user_id_from_search
	where object_id = :object_id
    }

    db_dml update_owner {
	update acs_objects
	set creation_user = :user_id_from_search
	where object_id = :object_id
    }

    # Log owner change
    db_dml log_change {
	insert into sn_owner_history
	  (object_id, change_user_id, old_user_id, new_user_id, change_date, reason)
	values
	  (:object_id, :user_id, :author_id, :user_id_from_search, sysdate, :reason)
    }
}

ad_returnredirect $page_url
