ad_page_contract {
    /www/library/owner-change.tcl

    Let the user search for the new object owner.

    @cvs-id $Id: owner-change.tcl,v 1.2 2005/03/01 00:01:14 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
} -properties {
    title:onevalue
    graphic:onevalue
    graphic_width:onevalue
    form_vars:onevalue
    owner_name:onevalue
    history:multirow
}

set user_id [auth::require_login]
if {![km_check_object_id $object_id]} { return }
if {![km_check_owner_change $object_id]} { return }

set object_name [km_conn object_name]
set object_type_id [km_conn object_type_id]
set pretty_type [km_static object_type_pretty_name $object_type_id]
set pretty_type_plural [km_static object_type_pretty_plural $object_type_id]w
set graphic [km_static object_type_graphic $object_type_id]
set graphic_width [library_icon_width]

set author_name [km_conn original_author_name]
set author_id [km_conn original_author_id]

set target "owner-change-2"
set passthrough {object_id category_id still_access_p reason page_url}
set page_url "object-view?object_id=$object_id&category_id=$category_id"

set title "Change Owner for $object_name"
set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Change owner"

set context_bar [list "owner-change?[export_url_vars object_id category_id]" "Change owner"]
if {[ad_conn user_id] == $author_id} {
    set show_myself_p f
} else {
    set show_myself_p t
}
set form_vars [export_form_vars target passthrough object_id category_id context_bar show_myself_p page_url]
set owner_name [ad_present_user $author_id $author_name]


template::multirow create history ch_by ch_from ch_to ch_date ch_reason
db_foreach get_owner_history {
	select change_user_id, u1.first_names||' '||u1.last_name as change_user_name,
	  old_user_id, u2.first_names||' '||u2.last_name as old_user_name,
	  new_user_id, u3.first_names||' '||u3.last_name as new_user_name,
	  change_date, reason
	from sn_owner_history h, users u1, users u2, users u3
	where h.object_id = :object_id
	  and change_user_id = u1.user_id
	  and old_user_id = u2.user_id
	  and new_user_id = u3.user_id
	order by change_date
} {
    template::multirow append history "[ad_present_user $change_user_id $change_user_name]" "[ad_present_user $old_user_id $old_user_name]" "[ad_present_user $new_user_id $new_user_name]" "$change_date" "$reason"
}

ad_return_template
