ad_page_contract {
    /packages/library/www/private-group-create.tcl

    @cvs-id $Id: private-group-create.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
    group_name:notnull
}
csrf::authenticate

set user_id [auth::require_login]

if { [db_string check_if_exists {
    select decode(count(*),0,0,1) from dual where exists
    (select 1
     from groups g, acs_objects o
     where lower(g.group_name) = lower(:group_name)
	and o.object_id = g.group_id
	and o.object_type = 'private_group'
	and o.creation_user = :user_id)}] } {
    ad_return_complaint 1 "<li>You already have defined a private group with that name."
    return
}

set peeraddr [ns_conn peeraddr]

# Create private group, and allow its members to view and edit
# the knowledge object. Grant admin rights for this group
# to the current user.

set group_id [db_exec_plsql create_group {
    begin
	:1 := private_group.new(
	    group_name => :group_name,
	    creation_user => :user_id,
	    creation_ip => :peeraddr,
	    join_policy => 'closed');
	acs_permission.grant_permission(:1, :user_id, 'admin');
    end;
}]

ad_returnredirect "object-access-add?[export_url_vars object_id category_id group_id]"
