ad_page_contract {
    /packages/library/www/publisher-change-2.tcl

    Change the publisher of an object.

    @cvs-id $Id: publisher-change-2.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
    object_id:notnull,integer
    user_id_from_search:notnull,integer
    {page_url:notnull}
}
csrf::authenticate

set user_id [auth::require_login]
set package_id [ad_conn package_id]
if {![km_check_object_id $object_id]} { return }
if {![ad_permission_p -user_id $user_id_from_search $package_id km_publish]} {
    ad_return_complaint 1 "The new publisher has to have the publish permission."
    return
}

set publisher_id [km_conn publisher_id]
set admin_p [km_conn admin_p]
set publish_p [km_conn publish_p]

if {!$admin_p && !$publish_p && $publisher_id != $user_id} {
    ad_return_complaint 1 "Not sufficient permissions."
    return
}

# Everything seems fine.

# Update the publisher
db_dml update_publisher {
    update sn_objects
    set publisher_id = :user_id_from_search
    where object_id = :object_id
}

ad_returnredirect $page_url
