ad_page_contract {
    /www/library/publisher-change.tcl

    Let the user search for the new object publisher.

    @cvs-id $Id: publisher-change.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
    object_id:notnull,integer
    {category_id ""}
} -properties {
    title:onevalue
    graphic:onevalue
    graphic_width:onevalue
    form_vars:onevalue
    publisher_name:onevalue
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]
if {![km_check_object_id $object_id]} { return }

set object_name [km_conn object_name]
set object_type_id [km_conn object_type_id]
set pretty_type [km_static object_type_pretty_name $object_type_id]
set pretty_type_plural [km_static object_type_pretty_plural $object_type_id]w
set graphic [km_static object_type_graphic $object_type_id]
set graphic_width [library_icon_width]
set admin_p [km_conn admin_p]
set publish_p [km_conn publish_p]
set publisher_id [km_conn publisher_id]

if {!$admin_p && !$publish_p && $publisher_id != $user_id} {
    ad_return_complaint 1 "Not sufficient permissions."
    return
}

db_1row get_publisher_name {
    select first_names || ' ' || last_name as publisher_name
    from users
    where user_id = :publisher_id
}

set target "publisher-change-2"
set passthrough {object_id category_id still_access_p reason page_url}
set page_url "object-view?object_id=$object_id&category_id=$category_id"
set extra_permission "km_publish"
set extra_package_id $package_id

set title "Change Publisher for $object_name"
set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Change publisher"

set context_bar [list "publisher-change?[export_url_vars object_id category_id]" "Change publisher"]
if {$user_id == $publisher_id} {
    set show_myself_p f
} else {
    set show_myself_p t
}
set form_vars [export_form_vars target passthrough object_id category_id context_bar show_myself_p page_url extra_permission extra_package_id]

ad_return_template
