#  Displays this field for a form field.
#  Lists all of the existing links between ACS content and this
#  object. Shows the button that leads to content linking excursion.

if {![info exists value]} {
    set value ""
}

if {![info exists edit_p]} {
    set edit_p 0
}

if {![info exists category_id]} {
    set category_id ""
}

if {![info exists size]} {
    set size 30
}

if {![info exists maxlength]} {
    set maxlength 50
}

if {![info exists hit_database_p]} {
    set hit_database_p 1
}

if [empty_string_p $value] { set value "Link" }

set return_url "one-question-edit?[export_url_vars object_id question_id category_id]"
set path_vars [list question_id $question_id object_id $object_id category_id $category_id]
set path_id [init_path $path_vars $return_url add_content_ref]
set admin_p [km_conn admin_p]

if { $question_state != "read-only" || [km_conn admin_p] } {
    array set node [site_node_closest_ancestor_site_node "acs-subsite"] 
    set community_id $node(package_id) 
}

if { $hit_database_p } {
    set existing_links [km8_get_to_links $object_id $question_id]
    set pass [ns_urlencode "$path_id:exclude [map fst $existing_links]"]
} else {
    set existing_links {}
    set pass $path_id
}
