# Displays a date field. It knows what default dates it should use for
# different object types that have dates.

if {![info exists value]} {
    set value ""
}

if {![info exists object_type_id]} {
    set object_type_id 0
}

if {!$object_type_id} { 
    set object_type_id [km_get_object_type $object_id] 
}

if {![empty_string_p $value]} {
    if { $question_state == "read-only" && ![km_conn admin_p] } {
        set read_only_p t
        set formatted_value [util_AnsiDatetoPrettyDate $value]
    } else {
        #break it up into form tag boxes
        set read_only_p f
        set date [km_break_date $value] 
        util_unlist $date year_value month_value day_value
    }
} else {
    set read_only_p f
    set date [km_default_date $question_id]
    util_unlist $date year_value month_value day_value
}

