# Displays the form field for a linking question: all already linked objects 
# and the possibility to add new links.

if {![info exists path_id]} {
    set path_id ""
}

if {![info exists category_id]} {
    set category_id ""
}

if {![info exists return_url]} {
    set return_url ""
}

if {![info exists hit_database_p]} {
    set hit_database_p 1
}

set field ""
util_unlist [km_link_question_attributes $question_id] \
	object_type_id pretty_type pretty_plural graphic

set edit_links_p [ad_decode $question_state "read-only" 0 1]


# Sometimes we are called from places such as admin pages where there are
# no linked objects because there is no object_id ... 

set linked_object_ids {}
if { $object_id } {
    set linked_objects [km_get_linked_objects -question_id $question_id -from_p 1 $user_id $object_id]

    set linked_object_id_ix [lsearch [head $linked_objects] linked_object_id]
    foreach item [tail $linked_objects] {
	lappend linked_object_ids [lindex $item $linked_object_id_ix]
    }

} else {
    set linked_objects ""
}

if { $question_state != "read-only" || [km_conn admin_p] } {
    set target_object_type_id \
            [db_string km_content_link_field_10 \
            {select target_object_type_id 
    from sn_questions 
    where question_id=:question_id}]

    array set node [site_node_closest_ancestor_site_node "acs-subsite"] 
    set community_id $node(package_id) 
    set read_only_p f
    set pass [ns_urlencode "$path_id:restriction${target_object_type_id}:exclude $linked_object_ids"]
} else {
    set read_only_p t
}
