ad_page_contract {
    /packages/library/www/resource-application-add.tcl

    Show a confirmation form or redirect to saved and unsent form

    @author Timo Hentschel (timo@arsdigita.com)
    @cvs-id $Id: resource-application-add.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
    object_id:notnull,integer
    resource_req_id:integer
    {category_id ""}
    {return_url "."}
} -properties {
    title:onevalue
    form_vars:onevalue
    project_graphic:onevalue
    graphic_width:onevalue
}

set user_id [auth::require_login]
if ![km_check_object_id $object_id] { return }

if ![exists_and_not_null resource_req_id] {
    ad_return_complaint 1 "For some reason, resource_req_id has not been supplied with this request."
    return
}

set unfinished_applications_p [db_0or1row get_unfinished_applications {
    select application_id
    from psn_res_applications
    where sent_p = 'f'
    and object_id = :object_id
    and resource_req_id = :resource_req_id
    and user_id = :user_id
}]

if {$unfinished_applications_p} {
    ad_returnredirect "resource-application-edit?[export_url_vars application_id category_id return_url]"
}

set project_type_id [km_conn object_type_id]
 set pretty_project_type [km_static object_type_pretty_name $project_type_id]
set project_graphic [km_static object_type_graphic $project_type_id]
set project_name [km_conn object_name]
set title "Apply for $pretty_project_type \"$project_name\""
set graphic_width [library_icon_width]

set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data "Confirm"

set form_vars [export_form_vars object_id resource_req_id category_id return_url]

db_release_unused_handles

ad_return_template
