ad_page_contract {
    script to recieve the new file and insert it into the database

    @author Timo Hentschel (timo@arsdigita.com)
    @creation-date 26 Oct 2001
    @cvs-id $Id: resource-application-attach-2.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
    application_id:integer,notnull
    {category_id ""}
    return_url:notnull
    upload_file:notnull,trim
    upload_file.tmpfile:tmpfile
} 
csrf::authenticate

set user_id [auth::require_login]
set target "resource-application-edit?[export_url_vars application_id category_id return_url]"

if {[doubleclick::check_all]} {
    ns_sleep 2
    ad_returnredirect $target
    return
}

# get the filename part of the upload file
if ![regexp {[^//\\]+$} $upload_file filename] {
    # no match
    set filename $upload_file
}

set mime_type [ns_guesstype $upload_file]

db_transaction {

    set attachment_id [db_nextval "psn_attachment_id_seq"]

    db_dml insert_attachment {
	insert into psn_attachments
	(attachment_id, application_id, title, mime_type, filename)
	values
	(:attachment_id, :application_id, :filename, :mime_type, :filename)
    }

    db_dml add_attachment_to_application {
	update psn_attachments
	set    attachment = empty_blob()
	where  attachment_id = :attachment_id
	returning attachment into :1
    } -blob_files [list ${upload_file.tmpfile}]

}

db_release_unused_handles

ad_returnredirect $target
