ad_page_contract {
    page to add a new file to the application

    @author Timo Hentschel (timo@arsdigita.com)
    @creation-date 26 Oct 2001
    @cvs-id $Id: resource-application-attach.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $
} {
    application_id:integer,notnull
    {category_id ""}
    return_url:notnull
} -properties {
    form_vars:onevalue
    title:onevalue
    dc_export:onevalue
}

set user_id [auth::require_login]

set application_exists [db_0or1row check_existing_application {
    select object_id, user_id as application_user_id, sent_p
    from psn_res_applications
    where application_id = :application_id
}]
if !$application_exists {
    ad_return_complaint 1 "There is no such application."
    return
}
if {![string equal $user_id $application_user_id]} {
    ad_return_complaint 1 "This is not your application. Your are not allowed to edit it."
    return
}
if {$sent_p == "t"} {
    ad_return_complaint 1 "This application already got sent. There is no way to edit it later, but you can sent a new application."
    return
}

set form_vars [export_form_vars application_id category_id return_url]
set title "Attach File to Application Form"

if ![km_check_object_id $object_id] { return }

set_the_usual_klib_context_bar $object_id $category_id
append_context_bar_data [list "resource-application-edit?[export_url_vars application_id category_id return_url]" "Apply"] "Attach File"

set dc_export [doubleclick::signature_html]

db_release_unused_handles

ad_return_template

