# /www/library/user-link-add.tcl
#
# $Id: user-link-add.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $

ad_page_contract {

} {
    user_id_from_search:notnull,integer
    email_from_search:notnull
    path_id:notnull,integer
}
csrf::authenticate

if ![path_valid_p $path_id] {
    ad_return_error "Invalid Path" \
	"The current path ID is invalid. Perhaps you used your browser's Back button
	 and tried to add another user?"
    return
}

set user_id [auth::require_login]

# Determine to which object we are going to add the user reference,
# and if the current user is allowed to do this.

set values [get_path_values -action_only_p 0 $path_id]
set object_id [value_from_tuples $values object_id]
set question_id [value_from_tuples $values question_id]
set category_id [value_from_tuples $values category_id]

if ![km_check_object_id -check_edit_p 1 $object_id] { return }

set link_type bi_directional

set new_link_id [db_string km_link_objects_10 "select
sn_links_seq.nextval from dual"]

db_transaction {

db_dml user_link_add_20 {insert into sn_links (link_id, link_type, object_id_a,
object_id_b, creation_user, creation_date)
values (:new_link_id, :link_type, :object_id,
:user_id_from_search, :user_id, sysdate)}

set content "Added link to user [DoubleApos $email_from_search]"
set ip_address [ns_conn peeraddr]
db_exec_plsql user_link_add_30 {
    begin
    object.audit_object (
    v_object_id              => :object_id,
    v_question_id            => :question_id,
    v_last_modifying_user_id => :user_id,
    v_modifying_ip           => :ip_address,
    v_content                => :content
    );
    end;
}


db_dml km_link_objects_40 {insert into sn_question_link_map (link_id, question_id)
values (:new_link_id, :question_id)}

}

# All done, back to the path's origin.

ad_returnredirect [get_path_return_url $path_id]
