# /www/library/user-link-delete-2.tcl
#
# Delete an object-user link.
#
# $Id: user-link-delete-2.tcl,v 1.2 2005/03/01 00:01:15 jeffd Exp $

ad_page_variables {
    link_id
    return_url
}
csrf::authenticate

set user_id [auth::require_login]

# We are dealing with object <-> user links here.
# The following query relies on the object being
# referenced by the object_id_a column.

set context_id [ad_conn package_id]
if {![db_0or1row user_link_delete_2_10 {
    select l.object_id_a as object_id, u.email, map.question_id
    from sn_links l, users u, sn_question_link_map map
    where l.link_id=:link_id 
        and map.link_id = l.link_id
        and l.object_id_b = u.user_id}]} {
    # The link already has been deleted.

    ad_returnredirect $return_url
    return
}

# Check if the user is authorized to delete this link.

if ![km_check_object_id -check_edit_p 1 $object_id] { return }

# All checks passed - let's delete the row.

db_transaction {

    db_dml user_link_delete_2_20 "delete from sn_links where link_id=:link_id"
    set content "Deleted link to user [DoubleApos $email]"
    set ip_address [ns_conn peeraddr]
    db_exec_plsql user_link_delete_2_40 {
	begin
	object.audit_object (
	v_object_id              => :object_id,
	v_question_id            => :question_id,
	v_last_modifying_user_id => :user_id,
	v_modifying_ip           => :ip_address,
	v_content                => :content
	);
	end;
    }


    db_dml user_link_delete_2_50 "
        update sn_objects 
        set last_modified = sysdate, last_modifying_user_id = :user_id
        [km_link_description_update $object_id $question_id]
        where object_id = :object_id"

}

ad_returnredirect $return_url
