ad_library {

    The Scanner procs for the MP3 Jukebox
    
    @author peterv@ybos.net
    @creation-date Mar-02-2001
    @cvs-id $Id: scanner-procs.tcl,v 1.3 2002/09/10 22:23:09 jeffd Exp $
}

ad_proc -private mp3_opendir {
    dir 
    {file_type f} 
    {return_style short}
} { 
    Use: opendir dir ?file_type? ?return_style?
    return a list of files or directories.
    Arguments:    dir  Directory to return (required)
            file_type  "d" for directories,
                       "f" for files (default),
                       "a" for all
         return_style  "short" for filenames only,
                       "long" for full paths
   Returns list of files/directories on success, "" on failure
} {
  set temp_dirs ""
  set temp_files ""
  set files [glob -nocomplain "$dir/*"]

  foreach file $files {
      if {[file isfile $file] == 1} {lappend temp_files $file}
      if {[file isdirectory $file] == 1} {lappend temp_dirs $file}
  }

  switch $file_type {
     a { set out [concat $temp_files $temp_dirs]}
     f { set out $temp_files }
     d { set out $temp_dirs }
     default {error "File type argument $file_type not known. Must be d f or a"}
  }
  switch $return_style {
     long { return $out }
     short {
        set short_out ""
        foreach file $out {
            lappend short_out [file tail $file]
        }
        return $short_out
     }
     default {error "Return type argument $return_style not known. Must be short or long"}
  }
}



ad_proc -public get_list_of_mp3s {
} {
    This proc uses the package_id to check an appropriate directory.
    It uses ad_parameter to check the MP3FileLocation variable.
} {
    set package_id [ad_conn package_id]
    set staging_path [ad_parameter -package_id $package_id MP3StagingLocation]
    # set file_list [exec /usr/bin/find [ad_parameter -package_id $package_id MP3StagingLocation] ]
    set file_list [mp3_opendir $staging_path]
    
    return $file_list
}

ad_proc -public mp3_name_from_file { filename } {
    
} {
    if { [regexp {([^/]*)\.[mM][Pp]3$} $filename match mp3_name] } {
	return $mp3_name
    } else {
	return "Not AN MP3 File Name!"
    }
}

