# /packages/mp3jukebox/www/admin/mp3-edit-2.tcl

ad_page_contract {

    This page edits an mp3 in the database
    and redirects to admin/index.tcl

    @author wirth@ybos.net
    @creation-date 2000-03-08

} {
    mp3_id:naturalnum,notnull
    file_path:notnull
    title:notnull
    artist
    bitrate
    album
    genre
    year
    layer
    {copyright_p ""}
    tracknum
    version
    mode_num
    {stereo_p ""}
    frequency
    minutes
    seconds
    comments
    {vbr_p ""}
   
}

#requires admin permission as under /admin

# take empty strings and make them null values before inserting them in db
set mp3_variables [list file_path title artist bitrate album genre year layer copyright_p tracknum version mode_num stereo_p frequency minutes seconds comments vbr_p]

foreach var $mp3_variables {

    if { [empty_string_p [set $var]] } {
	set var [db_nullify_empty_string [set $var]]
    }
}

if [catch { 
    db_dml mp3_edit "update mp3_mp3s
set 
     file_path = :file_path,
     title = :title,
     artist = :artist,
     bitrate = :bitrate,
     album = :album,
     genre = :genre,
     year = :year,
     tracknum = :tracknum,
     layer = :layer,
     copyright_p = :copyright_p,
     version = :version,
     mode_num = :mode_num,
     stereo_p = :stereo_p,
     frequency = :frequency,
     minutes = :minutes,
     seconds = :seconds,
     comments = :comments,
     vbr_p = :vbr_p
where mp3_id = :mp3_id
"
} errmsg ] {

    set complaint " The database did not accept your input. 
	See details for the error message below\n\n\t<p><b>$errmsg</b>"
    ad_return_error "Database Error" "$complaint" 
    ad_script_abort

} else {

    ad_returnredirect index

}    



