#mp3/www/admin/one-playlist.tcl
ad_page_contract {

    Lists properties of one playlist including related mp3s

    @author wirth@ybos.net
    @creation-date 2000-03-02

} {

    playlist_id:naturalnum,notnull
    new_mp3:optional
    
} -properties {

    page_title:onevalue
    context:onevalue
    name:onevalue
    playlist_mp3s:multirow
    playlist_info
    remove_threshold
    playlist_id:onevalue
    shuffle_y_or_n
    new_mp3:onevalue
}

#requires admin permission as under /admin

# @author jennie@ybos.net
db_1row playlist_info "
    select name, remove_threshold, nvl(sc.songs,0) as songs, mp.playlist_id
     from mp3_playlists mp,
          mp3_playlist_song_count sc
     where mp.playlist_id=:playlist_id
     and   sc.playlist_id(+) = mp.playlist_id
"

set title "Playlist: $name"
set context [list $title]
set page_title "Playlist: $name"

set package_id [ad_conn package_id]
#ad_require_permission $package_id mp3_view_playlist

db_multirow playlist_mp3s mp3_info "
    select sort_key,
    mp.title as title, map.mp3_id as mp3_id, total,
    decode (sign ((total - :remove_threshold)),1,'t','f') as active_p
    from mp3_mp3_playlist_map_view map, 
    mp3_mp3s_not_deleted mp
    where playlist_id=:playlist_id
     and map.mp3_id=mp.mp3_id
    order by sort_key
"

#remove_threshold is usually a negative number in the database - we make it 
#positive here for user interface
set ui_remove_threshold [expr -1 * $remove_threshold]

set highest_sortkey_in_list [db_string order_maxkey_get "select max(sort_key)
	    from mp3_mp3_playlist_map 
            where playlist_id=:playlist_id
            "]

ad_return_template