#mp3/www/admin/playlist-item-remove.tcl

ad_page_contract {

    Removes an item (e.g. an mp3) from a playlist

    @author Elizabeth Wirth (wirth@ybos.net)
    @creation-date 2001-03-05
} {

    mp3_id:naturalnum,optional
    playlist_id:naturalnum,notnull
}

#requires admin permission as under /admin

if [catch {
    db_exec_plsql remove_item "
	begin
	  mp3_playlist.item_remove (
		mp3_id => :mp3_id,
		playlist_id => :playlist_id
		);
	end;
   "
} errmsg ] {

    set complaint " The database did not accept your input. 
	See details for the error message below\n\n\t<p><b>$errmsg</b>"
    ad_return_error "Database Error" "$complaint" 
    ad_script_abort
	
} else {

    ad_returnredirect one-playlist?[export_url_vars playlist_id]

}