ad_library {
    @author Andrew Grumet <aegrumet@arsdigita.com>
    @cvs-id $Id: bulk-upload-procs.tcl,v 1.2 2002/09/10 22:23:13 jeffd Exp $
}

ad_proc pl_bulk_insert {
    {-use_default_date 0}
    {-use_default_prefix 0}
    folder_id
    server_tempnam
} {

    Upload a zip file full of pictures.
    Shamelessly copied from Wimpy Point.
    Thank You Nuno Santos <nuno@arsdigita.com>.

} {
    # Step 1: Create temp directory.

    set tmp_dir [file dirname $server_tempnam]
    append tmp_dir "/[ns_mktemp "$folder_id-XXXXXX"]"
    if [catch { ns_mkdir $tmp_dir } errMsg ] {
	ns_log Notice "photo-album-lite: Error creating directory $tmp_dir: $errMsg"
	return -code error "photo-album-lite: there was an error unzipping your file.  Please contact <a href=\"mailto:[ad_admin_owner]\">the server administrator</a> for assistance."
    }

    # Step 2: Unzip the archive

    set unzip_home [ad_parameter PathToUnzip photo-album-lite /usr/bin]

    # unzip -C -j zipfile *.gif *.jpg -d directory 
    #   only extract GIFs and JPGs (-C=case-insensitive) into directory;
    #   don't create subdirs (-j);
    #   ignore "caution: filename not matched" unzip message
    #   (if one of the formats is not present in the archive)

    if { [catch { exec $unzip_home/unzip -C -j $server_tempnam *.gif *.jpg -d $tmp_dir } errMsg] && ![regexp {caution: filename not matched} $errMsg]} {
	ns_log Notice "photo-album-lite: Error unzipping $server_tempnam: $errMsg"
	file delete -force $tmp_dir
	return -code error "photo-album-lite: there was an error unzipping your file.  Please contact <a href=\"mailto:[ad_admin_owner]\">the server administrator</a> for assistance."
    }

    # Step 3: use glob to get a list of files in the directory
    set file_exts {[Gg][Ii][Ff],[Jj][Pp][Gg]}
    set image_file_list [lsort [glob -nocomplain $tmp_dir/*.{$file_exts}]]

    # Step 4: loop through the files and do the insert

    foreach image_file $image_file_list {
	if [catch {pl_photo_insert -use_default_date $use_default_date -use_default_prefix $use_default_prefix $folder_id $image_file} errMsg] {
	    global errorInfo
	    return -code error "photo-album-lite: sorry, there was an error: $errMsg"
	}
    }

    # Step 5: clean up 

    file delete -force $tmp_dir

}
