# /www/master-default.tcl
#
# Set basic attributes and provide the logical defaults for variables that
# aren't provided by the slave page.
#
# Author: Kevin Scaldeferri (kevin@arsdigita.com)
# Creation Date: 14 Sept 2000
# default-master.tcl,v 1.2 2000/09/27 20:32:06 lars Exp
#

# Slideshow Interval
set slideshow_interval [ad_parameter SlideShowInterval photo-album-lite 5]

# Title

if ![exists_and_not_null title] {
    set title [ad_system_name]
}

# Signatory

if ![exists_and_not_null signatory] {
    set signatory [ad_system_owner]
}

# Attributes

array set attrs [list]

set attrs(bgcolor) [ad_parameter bgcolor "" "white"]
set attrs(text) [ad_parameter textcolor "" "black"]

if { [exists_and_not_null focus] } {
    set attrs(onLoad) "javascript:document.${focus}.focus()"
}

foreach attr [array names attrs] {
    lappend attr_list "$attr=\"$attrs($attr)\""
}

set attributes [join $attr_list " "]



# Developer-support

if { [llength [namespace eval :: info procs ds_link]] == 1 } {
     set ds_link "[ds_link]"
} else {
    set ds_link ""
}
