ad_page_contract {
    
    @author Andrew Grumet <aegrumet@arsdigita.com>
    @cvs-id $Id: bulk-image-upload-2.tcl,v 1.3 2005/03/01 00:01:16 jeffd Exp $

    Upload a zip file full of pictures.
    Shamelessly copied from Wimpy Point.
    Thank You Nuno Santos <nuno@arsdigita.com>.

} {

    folder_id:notnull,naturalnum
    file:notnull
    file.tmpfile:notnull

}

# auth::require_login
# doesn't work with file attachments :(
set caller_id [ad_conn user_id]

if !$caller_id {
    ad_return_complaint 1 "Sorry, you don't appear to be logged in.  Please <a href=\"/register/index\">log in</a> and try again."
}

ad_require_permission $folder_id write

# Step 1: Create temp directory.

set tmp_dir [file dirname ${file.tmpfile}]
append tmp_dir "/[ns_mktemp "$folder_id-XXXXXX"]"
if [catch { ns_mkdir $tmp_dir } errMsg ] {
    ns_log Notice "photo-album-lite: Error creating directory $tmp_dir: $errMsg"
    ad_return_error "Unzip Error" "There was an error unzipping your file.  Please contact <a href=\"mailto:[ad_admin_owner]\">the server administrator</a> for assistance."
    ad_script_abort
}

# Step 2: Unzip the archive

set unzip_home [ad_parameter PathToUnzip photo-album-lite /usr/bin]

# unzip -C -j zipfile *.gif *.jpg -d directory 
#   only extract GIFs and JPGs (-C=case-insensitive) into directory;
#   don't create subdirs (-j);
#   ignore "caution: filename not matched" unzip message
#   (if one of the formats is not present in the archive)

if { [catch { exec $unzip_home/unzip -C -j ${file.tmpfile} *.gif *.jpg -d $tmp_dir } errMsg] && ![regexp {caution: filename not matched} $errMsg]} {

    ns_log Notice "photo-album-lite: Error unzipping $file.tmpfile: $errMsg"
    ad_return_error "Unzip Error" "There was an error unzipping your file.  Please contact <a href=\"mailto:[ad_admin_owner]\">the server administrator</a> for assistance."
    file delete -force $tmp_dir
    ad_script_abort
}


# Step 3: use glob to get a list of files in the directory
set file_exts {[Gg][Ii][Ff],[Jj][Pp][Gg]}
set image_file_list [lsort [glob -nocomplain $tmp_dir/*.{$file_exts}]]

# Step 4: loop through the files and do the insert

foreach image_file $image_file_list {
	if [catch {pl_photo_insert $folder_id $image_file} errMsg] {
	    global errorInfo
	    doc_return 200 text/plain "sorry, there was an error: $errMsg"
	}
}

# Step 5: clean up 

file delete -force $tmp_dir

ad_returnredirect photo-add?folder_id=$folder_id
