ad_page_contract {

    @author Andrew Grumet <aegrumet@arsdigita.com>
    @cvs-id $Id: photo-add-2.tcl,v 1.4 2005/03/01 00:01:16 jeffd Exp $

    Add up to 6 photos.

} {
  folder_id:notnull,naturalnum
  file1:optional
  file1.tmpfile:optional,tmpfile
  file2:optional
  file2.tmpfile:optional,tmpfile
  file3:optional
  file3.tmpfile:optional,tmpfile
  file4:optional
  file4.tmpfile:optional,tmpfile
  file5:optional
  file5.tmpfile:optional,tmpfile
  file6:optional
  file6.tmpfile:optional,tmpfile
  {use_default_date:optional,naturalnum 0}
  {use_default_prefix:optional,naturalnum 0}
}

# auth::require_login
# doesn't work with file attachments :(
set caller_id [ad_conn user_id]

if !$caller_id {
    ad_return_complaint 1 "Sorry, you don't appear to be logged in.  Please <a href=\"/register/index\">log in</a> and try again."
    ad_script_abort
}

ad_require_permission $folder_id write

foreach num [list 1 2 3 4 5 6] {
    if { [info exists file$num] && ![empty_string_p [set file$num]] } {
	set guessed_file_type [string tolower [ns_guesstype [set file$num]]]
	if { [lsearch [list image/gif image/jpeg application/x-zip-compressed] $guessed_file_type] < 0 } {
	    ad_return_complaint 1 "Sorry, only GIF, JPEG, and ZIP formats are allowed at this time.  Please make sure your images are in the correct format and that your filenames end in <code>.gif</code> or <code>.jpg</code>."
            ad_script_abort
	}
    }
}

foreach num [list 1 2 3 4 5 6] {
    if { [info exists file$num] && ![empty_string_p [set file$num]] } {

	set guessed_file_type [string tolower [ns_guesstype [set file$num]]]
	if [string equal $guessed_file_type application/x-zip-compressed] {
	    if [catch {pl_bulk_insert -use_default_date $use_default_date -use_default_prefix $use_default_prefix $folder_id [set file${num}.tmpfile]} errMsg] {
		global errorInfo
		doc_return 200 text/plain "sorry, there was an error: $errMsg"
                ad_script_abort
	    }
	} else {
	    if [catch {pl_photo_insert -use_default_date $use_default_date -use_default_prefix $use_default_prefix $folder_id [set file${num}.tmpfile] [set file$num]} errMsg] {
		global errorInfo
		doc_return 200 text/plain "sorry, there was an error: $errMsg"
                ad_script_abort
	    }

	}
    }
}

ad_returnredirect photo-add?folder_id=$folder_id
