ad_page_contract {

    @author Andrew Grumet <aegrumet@arsdigita.com>
    @cvs-id $Id: photo-edit-2.tcl,v 1.3 2002/09/13 10:44:01 jeffd Exp $

    Update photo information.

} {
    photo_id:notnull,naturalnum
    folder_id:notnull,naturalnum
    exp_date:array,date
    caption:optional
    root_name:notnull
    file_extension:notnull
}

ad_require_permission $photo_id admin
ad_require_permission $folder_id write

if [empty_string_p $exp_date(year)] {
    set exposure_date [db_null]
} else {
    set exposure_date "$exp_date(year)-$exp_date(month)-$exp_date(day)"
}

set client_filename [pl_photo_cleanup_filename "$root_name$file_extension"]

if { ![info exists caption] || [empty_string_p $caption] } {
    set caption [db_null]
}

db_transaction {
    # super-simple security: no dml and no warnings
    # if file_extension looks funny.
    db_dml pl_photo_update {
	update pl_photos
        set caption = :caption,
            client_filename = :client_filename,
            exposure_date = to_date(:exposure_date,'YYYY-MM-DD'),
            folder_id = :folder_id
       where photo_id in (  select photo_id
                            from pl_v_photos
                            where photo_id = :photo_id
                              and file_extension = :file_extension )
    }
    # maintain the sort_n's if/when the photo moves to a different folder.
    db_exec_plsql pl_reshuffle {begin pl_reshuffle; end;}
}

ad_returnredirect photo-edit?photo_id=$photo_id    
