ad_page_contract {

    @author Andrew Grumet <aegrumet@arsdigita.com>
    @cvs-id $Id: photo-edit.tcl,v 1.2 2002/09/10 22:23:14 jeffd Exp $

    Edit a photo.

} {
    photo_id:notnull,naturalnum
    {all_folders_p:optional,boolean 0}
}

set caller_id [ad_conn user_id]
set package_id [ad_conn package_id]

db_1row one_photo {
    select to_char(nvl(a.exposure_date,pl_photo.exp_date(pl_photo.prev_photo_id(a.folder_id,a.sort_n))),'YYYY-MM-DD') as exp_date,
           pl_photo_date_format(a.creation_date) as post_date,
           a.caption,
           a.client_filename,
           a.file_extension,
           a.folder_id,
           a.sort_n,
           pl_folder.photo_count(a.folder_id) as photo_count,
           pl_photo.folder_title(a.photo_id) as folder_title,
           pl_photo.next_photo_id(a.folder_id,a.sort_n,:caller_id,'admin')
            as next_photo_id,
           pl_photo.prev_photo_id(a.folder_id,a.sort_n,:caller_id,'admin') 
            as prev_photo_id,
           pl_relative_date(a.last_modified) as modified_date
    from pl_v_photos a
    where a.photo_id = :photo_id
}

set date_entry_widget [ad_dateentrywidget exp_date $exp_date]

set root_name [file rootname $client_filename]

set context_bar [ad_context_bar [list folder-view?folder_id=$folder_id $folder_title] "Edit photo $sort_n of $photo_count"]

if $all_folders_p {
    set my_folders_clause ""
} else {
    set my_folders_clause "and creation_user = :caller_id"
}

# Also query for folders this user can write to.
db_multirow writable writable_q "
    select folder_id,
           title
       from pl_v_folders
       where context_id = :package_id
         and acs_permission.permission_p(folder_id,:caller_id,'write') = 't'
         and folder_id != :folder_id
         $my_folders_clause
       order by lower(title)
"

set folder_urlvars [export_ns_set_vars url all_folders_p]
