ad_page_contract {

    @author Andrew Grumet <aegrumet@arsdigita.com>
    @cvs-id $Id: photo-search.tcl,v 1.2 2002/09/10 22:23:14 jeffd Exp $

    Search for photos whose captions contain the query string.

} {
    query:notnull
}

set context_bar [ad_context_bar "Search results"]
set package_id [ad_conn package_id]

# Plain old "contains" queries leave a lot to be desired
# but I can seem to get "about" queries to work :(
db_multirow results pl_query_results {
    select p.client_filename,
           p.photo_id,
           p.caption
    from pl_photos p,
         pl_v_folders f
    where p.deleted_p = 'f'
      and p.folder_id = f.folder_id
      and f.context_id = :package_id
      and contains(indexable_stuff,:query,1) > 0
    order by score(1) desc
}
