ad_page_contract {

    @author Andrew Grumet <aegrumet@arsdigita.com>
    @cvs-id $Id: photo-view.tcl,v 1.2 2002/09/10 22:23:14 jeffd Exp $

    Display a photo.

} {
    photo_id:notnull,naturalnum
    slide_show_p:optional,boolean
    paused_p:optional,boolean
}

set slideshow_interval [ad_parameter SlideShowInterval photo-album-lite 10]
set preload_p [ad_parameter ImagePreloadingEnabledP photo-album-lite 1]

set admin_p [ad_permission_p $photo_id admin]

set user_id [ad_conn user_id]
set package_id [ad_conn package_id]
set default_height [ad_parameter MediumHeight photo-album-lite 400]

db_1row one_photo {
    select a.client_filename,
           decode(a.med_width,NULL,'','width="' || a.med_width || '"') as width_tag,
           'height="' || nvl(a.med_height,:default_height) || '"' as height_tag,
           a.folder_id,
           pl_photo.folder_title(a.photo_id) as folder_title,
           nvl(pl_photo.next_photo_id(a.folder_id,a.sort_n),0) as next_photo_id,
           nvl(pl_photo.prev_photo_id(a.folder_id,a.sort_n),0) as prev_photo_id,
           pl_photo_date_format(a.creation_date) as post_date,
           pl_photo_date_format(a.exposure_date) as exp_date,
           a.caption,
           a.creation_user,
           person.name(a.creation_user) as photographer,
           a.sort_n,
           pl_folder.photo_count(a.folder_id) as photo_count,
           a.orig_width,
           a.orig_height,
           a.orig_kbytes,
           a.med_height
    from pl_v_photos a,
         pl_v_folders f
    where a.photo_id = :photo_id
      and a.folder_id = f.folder_id
      and f.context_id = :package_id
}

if ![exists_and_not_null slide_show_p] {
    set slide_show_p 0
} else {
    db_0or1row next_client_filename {
	select client_filename as next_client_filename
        from pl_v_photos
	where photo_id = :next_photo_id
    }
}

if ![exists_and_not_null paused_p] { set paused_p 0 }

set context_bar [ad_context_bar [list "folder-view?folder_id=$folder_id" $folder_title] "Photo $sort_n of $photo_count"]

foreach way [list next prev] {
    if [set ${way}_photo_id] {
	set ${way}_url photo-view?photo_id=[set ${way}_photo_id]
    } else {
	set ${way}_url folder-view?folder_id=$folder_id
    }
}

set top_url folder-view?folder_id=$folder_id

set photo_commentable_p [pl_photo_commentable_p $photo_id]

if $photo_commentable_p {
    set the_comments [general_comments_get_comments $photo_id]
    set general_comments_link [general_comments_create_link $photo_id [ns_conn url]?[ns_conn query]]
}
