ad_page_contract {
    Update the photo sort order for a folder.
    If photo_id_list doesn't exist, reorder by the exposure date.
} {
    folder_id:notnull,naturalnum
    photo_id_list:optional,naturalnum,multiple
    {rename:optional,boolean false}
}

ns_log Notice "rename: $rename"

ad_require_permission $folder_id admin

db_transaction {

    set id_list [db_list photo_ids_by_date {
	select photo_id
	from pl_photos
	where folder_id = :folder_id
	and deleted_p = 'f'
	order by exposure_date
        for update
    }]

    if ![info exists photo_id_list] { set photo_id_list $id_list }

    set counter 0

    foreach photo_id $photo_id_list {
	incr counter
	db_dml update_sort_n {
	    update pl_photos
	    set sort_n = :counter
	    where photo_id = :photo_id
	}
    }
}

if [string equal $rename true] {
    ad_returnredirect folder-set-defaults?folder_id=$folder_id&mode=name
} else {
    ad_returnredirect folder-view?folder_id=$folder_id&o=[ns_time]
}
