ad_page_contract {} {
    {last_name_start:trim ""}
}

set title "Edit ticket tracker users"

ttl_restrict_to_ttl_users

set caller_id  [ad_conn user_id]
set package_id [ad_conn package_id]

set context [list $title]

set return_url_clause [ttl_return_url_clause]

set master_template [ttl_master_template]

db_multirow users get_users {
    select 
        t.user_id,
        p1.first_names || ' ' || p1.last_name as full_name,
        p2.email,
        null as remove_link
    from ttl_v_users t, persons p1, parties p2
    where t.package_id = :package_id
    and t.user_id = p1.person_id
    and p1.person_id = p2.party_id
    order by lower(full_name)
} {
    set remove_link "member-ae?user_id=$user_id&action=remove&$return_url_clause"
}    

if ![string equal "" $last_name_start] {
    set user_search_p 1

    db_multirow user_search search_users {
        select 
            u.user_id,
            p2.email,
            p1.first_names,
            p1.last_name,
            null as add_link
        from users u, persons p1, parties p2
        where u.user_id = p1.person_id
        and p1.person_id = p2.party_id
        and not exists (select 1 
                        from ttl_v_users t
                        where t.package_id = :package_id
                        and t.user_id = u.user_id)
        and lower(last_name) like lower(:last_name_start) || '%'
        order by lower(last_name), lower(first_names)
    } {
        set add_link "member-ae?user_id=$user_id&$return_url_clause"
    }
} else {
    set user_search_p 0
}

set page_title "Ticket tracker users"
