ad_page_contract {
    
    A page to attach files

} {
    ticket_id:integer,notnull
    upload_file:trim,notnull
    upload_file.tmpfile:tmpfile
    {return_url "ticket"}
}

ttl_restrict_to_ttl_users

set caller_id  [ad_conn user_id]
set caller_ip  [ns_conn peeraddr]
set package_id [ad_conn package_id]

ns_log notice "vinodk-upload_file=$upload_file"

db_transaction {

    if {![empty_string_p $upload_file]} {
		set mime_type [ns_guesstype $upload_file]
		set file_extension [string trimleft [file extension $upload_file] "."]
		set revision_id [db_exec_plsql create_new_file "select ttl__create_file(:package_id, :caller_id, :upload_file, :ticket_id, :mime_type, :file_extension);"]
		db_1row get_item_id "select item_id from cr_revisions where revision_id = :revision_id"
		set tmp_filename [cr_create_content_file $item_id $revision_id ${upload_file.tmpfile}]
		set tmp_size [cr_file_size $tmp_filename]
		db_dml file_size_mime_type "update cr_revisions set content_length = :tmp_size, content = :tmp_filename where revision_id = :revision_id" -blob_files [list ${upload_file.tmpfile}]
    }

}


ad_returnredirect "$return_url"
