ad_page_contract {} {
    comment_id:integer,optional
    ticket_id:integer,optional
} -validate {
    one_of_two_exists {
        if {![info exists comment_id] && ![info exists ticket_id]} {
            ad_complain "Need either a comment_id or a ticket_id"
        }
    }
}

ttl_restrict_to_ttl_users

set caller_id [ad_conn user_id]

set master_template [ttl_master_template]

if [info exists comment_id] {

    db_1row get_comment {
        select
            c.message,
            c.message_format,
            t.ticket_id,
            t.name as ticket_name
        from ttl_comments c, ttl_v_tickets t
        where comment_id = :comment_id
        and c.ticket_id = t.ticket_id
    }

    set title "Edit comment for \"$ticket_name\""
    set button_name "Update"

    set Q_message [ns_quotehtml $message]
    set format_widget [ttl_text_format_widget -name message_format -default $message_format]

} else {

    db_1row get_ticket {
        select
            acs_object_id_seq.nextval as comment_id,
            name as ticket_name
        from ttl_v_tickets t
        where ticket_id = :ticket_id
    }

    set title "Attach comment to \"$ticket_name\""
    set button_name "Add comment"

    set Q_message ""

    set format_widget [ttl_text_format_widget -name message_format]
}

set context [list [list ticket?ticket_id=$ticket_id "Ticket $ticket_id"] "Add Comment"]

set hidden_vars [export_form_vars ticket_id comment_id]
