set caller_id [ad_conn user_id]

db_multirow comments get_comments {
    select
        r.comment_id,
        p.first_names || ' ' || p.last_name as comment_username,
        r.message,
        r.message_format,
        ttl_relative_date(r.creation_date) as comment_date,
        decode(:caller_id, r.creation_user, 1, 0) as can_edit_p,
        null as edit_url
    from ttl_va_comments r, persons p
    where r.ticket_id = :ticket_id
    and r.creation_user = p.person_id
} {
    set message [ttl_format_text_for_display -format $message_format -wrap 60 $message]
    if { $can_edit_p } {
        set edit_url "comment-ae?comment_id=$comment_id"
    }
}

