ad_page_contract {} {
    sort:trim,optional
    status:trim,optional
    mine_p:trim,optional
    area_id:integer,trim,optional
}

ttl_restrict_to_ttl_users

set caller_id [ad_conn user_id]

foreach variable_name [list sort status mine_p area_id] {
    if [info exists $variable_name] {
        append update_clause "\n    $variable_name = :$variable_name,"
    }
}


if [info exists update_clause] {

    db_dml update_prefs "update ttl_prefs set [string trimright $update_clause ,] where user_id = :caller_id"

    if {[db_resultrows] == 0} {

        set sort    [ttl_util_default sort   priority]
        set status  [ttl_util_default status active]
        set mine_p  [ttl_util_default mine_p t]
        set area_id [ttl_util_default area_id]

        db_dml insert_pref {
        insert into ttl_prefs (user_id, sort, status, mine_p, area_id) 
        values (:caller_id, :sort, :status, :mine_p, :area_id)}
    }
}

ad_returnredirect index
