set caller_privilege [ttl_restrict_to_ttl_users]

set caller_id  [ad_conn user_id]
set package_id [ad_conn package_id]

set master_template [ttl_master_template]

db_1row get_ticket_id {
    select 
        acs_object_id_seq.nextval as ticket_id,
        (select count(*)
         from ttl_va_areas
         where context_id = :package_id) as num_areas
    from dual
}

if { $num_areas == 0 } { 
    if [string equal $caller_privilege admin] {
        set message "
            Before you can add a ticket, you need to 
            <a href=admin/area-ae?[ttl_return_url_clause]>add a feature area</a> 
            so the ticket can be categorized."
    } else {
        set message "
            Before you can add a ticket, you need an administrator
            to create feature areas so tickets can be categorized."
    }

    ttl_return_complaint "Wait!" $message
    ad_script_abort
}

set title "Add a ticket"
#set context [ttl_context]
set context [list [list "Add"]]

set type_optionlist     [ttl_type_optionlist]
set area_optionlist     [ttl_area_optionlist]
set priority_optionlist [ttl_priority_optionlist]
set status_optionlist   [ttl_status_optionlist]
set deadline_widget     [ad_dateentrywidget deadline]

set format_widget [ttl_text_format_widget -name message_format]
