<?xml version="1.0"?>

<queryset>
   <rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="get_one_ticket">      
<querytext>
      
select  t.area_id,
        a.name as area_name,
        t.name,
        t.type,
        t.status,
        t.message,
        t.message_format,
        t.priority,
        t.deadline,
        t.url,
        ttl_relative_date(t.creation_date) as posting_date,
        person.name(t.creation_user) as posting_name
    from ttl_v_tickets t, ttl_va_areas a
    where a.context_id = :package_id and 
          t.ticket_id = :ticket_id and 
          t.area_id = a.area_id

</querytext>
</fullquery>


 
<fullquery name="get_people">      
<querytext>
      
select * from (select p.first_names || ' ' || p.last_name as full_name,
                     t.user_id,
                     case when a.user_id = null then 0 else 1 end 
                       as already_assigned_p
                 from persons p, ttl_v_users t, (select user_id
                                                   from ttl_assignments
                                                   where ticket_id = :ticket_id) a
                 where t.package_id = :package_id and 
                       p.person_id = t.user_id and 
                       t.user_id = a.user_id(+)
                 order by upper(full_name)) 
  where rownum < 50

</querytext>
</fullquery>

 
</queryset>
