# /packages/ticket-tracker/wf-templates/ticket-info.tcl

ad_page_contract {
    Return info about a ticket.

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-11-26
    @cvs-id $Id: ticket-info.tcl,v 1.1 2001/04/20 20:51:25 donb Exp $
} -properties {
    category_name:onevalue
    ticket:onerow    
}    

# task is one of the datasources specified in the <include> tag in /packages/acs-workflow/www/task.adp
set ticket_id $task(object_id)
set category_name [ad_parameter CategoryName ticket-tracker Category]

db_1row ticket_info_select {
  select tt.ticket_id,
         ttracker_option.option_name(tc.package_id, 'severity', tt.severity) as pretty_severity,
         ttracker_option.option_name(tc.package_id, 'priority', tt.priority) as pretty_priority,
         tt.subject,
         tc.name as category,
         cr.content as description,
         cr.mime_type
    from ttracker_tickets tt,
         ttracker_categories tc,
         cr_revisions cr
   where tt.ticket_id = :ticket_id
     and tt.category_id = tc.category_id
     and cr.revision_id = content_item.get_live_revision(:ticket_id)
} -column_array {ticket} 

# if it's plain text, escape the html stuff
if [string equal $ticket(mime_type) "text/plain"] {
    set ticket(description) [ad_quotehtml $ticket(description)]
}


ad_return_template