# /packages/ticket-tracker/www/admin/category-add-2.tcl

ad_page_contract {
    Add a new category

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng   (tony@arsdigita.com)
    @creation-date 2000-11-22
    @cvs-id $Id: category-add-2.tcl,v 1.1 2001/04/20 20:51:25 donb Exp $
} {
    name:nohtml,notnull
    description:nohtml,optional
    default_assignee:integer
} -validate {
    name_is_ok -requires {name:notnull} {
        set package_id [ad_conn package_id]
        db_1row check_duplicate {
            select count(1) as duplicate
            from ttracker_categories 
            where upper(name) = upper(:name) and
                  package_id = :package_id
        }
        if { $duplicate } {
            ad_complain
        }
    }
} -errors {
    name_is_ok { A category with the same name already exists. }
} 

set package_id [ad_conn package_id]
set user_id [ad_conn user_id]
set creation_ip [ad_conn peeraddr]


# if default_assignee == none
if { $default_assignee == 0 } {
    set default_assignee [db_null]
}

db_exec_plsql create_new_category {
    begin
    :1 := ttracker_category.new (
      context_id => :package_id,
      creation_user => :user_id,
      creation_ip => :creation_ip,
      package_id => :package_id,
      name => :name,
      default_assignee => :default_assignee,
      description => :description
    );
    end;
}

ad_returnredirect "."
    
