# /packages/ticket-tracker/www/admin/category-add.tcl

ad_page_contract {
    Presents a form to add a new category

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-11-26
    @cvs-id $Id: category-add.tcl,v 1.4 2002/09/06 12:43:37 jeffd Exp $
} -properties {
    context:onevalue
    page_title:onevalue
    target:onevalue
    submit:onevalue
    name:onevalue
    description:onevalue
    default_assignee:onevalue
    category_id:onevalue
    assignee:multirow
}

set package_id [ad_conn package_id]
set category_name [string tolower [ad_parameter CategoryName "ticket-tracker" "Category"]]
set page_title "Create a $category_name"
set context [list "Create a $category_name"]
set target "category-add-2"
set submit "Create"

# creating a brand new category; no default values exist
set name ""
set description ""
set default_assignee ""
set category_id ""

# get the potential assignees
db_multirow assignee assignees_select {
    select 0 as party_id, 'Nobody' as party_name from dual
    UNION ALL
    select p.party_id, acs_object.name(p.party_id) as party_name
    from parties p
}

ad_return_template "category-ae"
