# /packages/ticket-tracker/www/admin/category-delete-2.tcl

ad_page_contract {
    Deletes a category

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-11-26
    @cvs-id $Id: category-delete-2.tcl,v 1.2 2002/09/18 13:04:25 jeffd Exp $
} {
    category_id:integer
    { transfer_id:integer 0 }
    submit:notnull
}

if { $submit == "Proceed" } {
    set package_id [ad_conn package_id]
    # check that more than 1 category exists
    db_1row check_category {
        select count(category_id) as num_categories
          from ttracker_categories
         where package_id = :package_id
    }
    
    if { $num_categories > 1 } {
        db_transaction {
            # transfer the tickets over
            db_dml transfer_tickets {
                update ttracker_tickets
                   set category_id = :transfer_id
                 where category_id = :category_id
            }
            
            # delete the category
            db_dml delete_category {
                delete from ttracker_categories
                 where category_id = :category_id
            }

            # check to see that there is STILL one category left
            # since we do not know if another user is deleting
            # at the same time
            if { ![db_0or1row check_category_again {
                      select count(category_id)
                        from ttracker_categories
                       where package_id = :package_id }] } {
                           db_abort_transaction
                           ad_return_complaint 1 "<li>You cannot delete this category. There needs to be at least one category for each ticket tracker instance."
                ad_script_abort
            }            
        } on_error {
            ns_log Error "$errmsg"
        }
    } else {
        ad_return_complaint 1 "You cannot delete this category. There needs to be at least one category for each ticket tracker instance."
        ad_script_abort
    }
}
        
ad_returnredirect ""

