# /packages/ticket-tracker/www/admin/category-delete.tcl

ad_page_contract {
    Provides datesource to build a form to delete category

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-11-26
    @cvs-id $Id: category-delete.tcl,v 1.3 2002/09/06 12:43:37 jeffd Exp $
} {
    category_id:integer
} -properties {
    category_name:onevalue
    page_title:onevalue
    context:onevalue
    num_categories:onevalue
    num_tickets:onevalue
    categorie:multirow
}

set package_id [ad_conn package_id]
set category_name [string tolower [ad_parameter CategoryName "ticket-tracker" "Category"]]
set page_title "Delete $category_name"
set context [list "Delete $category_name" ]

# number of categories within this ticket tracker
set num_categories [db_string get_num_categories {
    select count(category_id)
      from ttracker_categories
     where package_id = :package_id
}]

# number of tickets within this category
set num_tickets [db_string get_num_tickets {
    select count(ticket_id)
      from ttracker_tickets
     where category_id = :category_id
}]

# get other categories
db_multirow category category_select {
    select name, category_id
      from ttracker_categories
     where package_id = :package_id
       and category_id <> :category_id
}
    
ad_return_template
