# /packages/ticket-tracker/www/admin/category-edit-2.tcl

ad_page_contract {
    Edit an existing category

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng   (tony@arsdigita.com)
    @creation-date 2000-11-22
    @cvs-id $Id: category-edit-2.tcl,v 1.1 2001/04/20 20:51:25 donb Exp $
} {
    category_id:integer,notnull
    name:nohtml,notnull
    description:nohtml,optional
    default_assignee:integer
} -validate {
    name_is_ok -requires {name:notnull category_id:integer} {
        set package_id [ad_conn package_id]
        if { [db_0or1row check_duplicate {
                  select category_id 
                    from ttracker_categories 
                   where upper(name) = upper(:name) and
                         package_id = :package_id and
                         category_id != :category_id}] } {
            ad_complain
        }
    }
} -errors {
    name_is_ok { Another category with the same name already exists. }
}

# if default_assigness == none
if { $default_assignee == 0 } {
    set default_assignee [db_null]
}

db_dml category_update {
    update ttracker_categories 
       set name = :name, 
           description = :description, 
           default_assignee = :default_assignee
     where category_id = :category_id
}

ad_returnredirect ""
    
