# /packages/ticket-tracker/www/admin/categor-edit.tcl

ad_page_contract {
    Presents a form to edit an existing category

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-11-26
    @cvs-id $Id: category-edit.tcl,v 1.4 2002/09/06 12:43:37 jeffd Exp $
} {
    category_id:integer
} -properties {
    context:onevalue
    page_title:onevalue
    name:onevalue
    description:onevalue
    default_assignee:onevalue
    category_id:onevalue
    target:onevalue
    submit:onevalue
    potential_assignee:multirow
}

set package_id [ad_conn package_id]
set category_name [string tolower [ad_parameter CategoryName "ticket-tracker" "Category"]]
set page_title "Edit a $category_name"
set context [list  "Edit a $category_name" ]
set target "category-edit-2"
set submit "Edit"

# get the category information
db_1row category_info_select {
    select name, description, default_assignee
    from ttracker_categories
    where category_id = :category_id
}

if [empty_string_p $default_assignee] {
    set default_assignee 0
}

# get the potential assignees
db_multirow assignee assignees_select {
    select 0 as party_id, 'Nobody' as party_name from dual
    UNION
    select p.party_id, acs_object.name(p.party_id) as party_name
    from parties p
}

ad_return_template "category-ae"
