# /packages/ticket-tracker/www/admin/index.tcl

ad_page_contract {
    Returns a list of categories and potential assignees under this ttracker

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-11-26
    @cvs-id $Id: index.tcl,v 1.2 2002/09/06 06:57:05 jeffd Exp $
} -properties {
    context:onevalue
    category:multirow
    assignee:multirow
    option:multirow
    category_name:onevalue
    category_plural_name:onevalue
}    

set package_id [ad_conn package_id]
set context {}
set category_name [string tolower [ad_parameter CategoryName "ticket-tracker" "Category"]]
set category_plural_name [ad_parameter CategoryPluralName "ticket-tracker" "Categories"]

# get the categories belong to this ticket tracker
db_multirow category categories_select {
    select name, category_id 
      from ttracker_categories
     where package_id = :package_id
     order by name
}

# get the options
db_multirow option options_select {
    select name,
           value,
           function,
           option_id
      from ttracker_options
     where package_id = :package_id
     order by function,value
}

ad_return_template
