# /packages/ticket-tracker/www/admin/option-add-2.tcl

ad_page_contract {
    Add a new severity or priority option

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-12-14
    @cvs-id $Id: option-add-2.tcl,v 1.1 2001/04/20 20:51:25 donb Exp $
} {
    function:notnull   
    name:trim,notnull
    value:trim,integer
} -validate {
    check_function -requires {function:notnull} {
        if { ![string equal $function "severity"] && ![string equal $function "priority"] } {
            ad_complain
        }
    }
    
    check_duplicate -requires {check_function value:integer name:notnull} {
        set package_id [ad_conn package_id]
        db_1row duplicate_count {
            select count(*) as duplicate
              from dual
             where exists (select option_id
                             from ttracker_options 
                            where package_id = :package_id
                              and function = :function
                              and (value = :value or upper(name) = upper(:name)))
        }
        if { $duplicate } {
            ad_complain
        }
    }
} -errors {
    check_function { Invalid function. }
    check_duplicate { An entry with the same name or value already exists }
} 

db_exec_plsql add_option {
    begin
        ttracker_option.add_option (
            package_id => :package_id,
            function => :function,
            name => :name,
            value => :value
        );
    end;
}

ad_returnredirect ""
