# /packages/ticket-tracker/www/admin/option-edit-2.tcl

ad_page_contract {
    Add a new severity or priority option

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-12-14
    @cvs-id $Id: option-edit-2.tcl,v 1.1 2001/04/20 20:51:25 donb Exp $
} {
    option_id:integer,ttracker_option_id
    function:notnull
    name:trim,notnull
    value:trim,integer
} -validate {
    is_duplicate -requires { option_id:ttracker_option_id 
                                function:notnull 
                                name:notnull 
                                value:integer} {
        set package_id [ad_conn package_id]
        db_1row duplicate_count {
            select count(*) as duplicate
              from dual
             where exists (select option_id
                             from ttracker_options 
                            where package_id = :package_id
                              and function = :function
                              and option_id <> :option_id
                              and (value = :value or upper(name) = upper(:name)))
        }
        if { $duplicate } {
            ad_complain
        }
    }
} -errors {
    is_duplicate { Another entry with the same name or value already exists. }
}

db_dml update_option {
    update ttracker_options
       set name = :name,
           value = :value
     where option_id = :option_id
}

ad_returnredirect ""


