<?xml version="1.0"?>

<queryset>
   <rdbms><type>postgresql</type><version>7.1</version></rdbms>

<fullquery name="category_info_select">      
      <querytext>
      
    select name, 
           description, 
           coalesce(acs_object__name(default_assignee), 'N/A') as assignee_name
      from ttracker_categories 
     where category_id = :category_id

      </querytext>
</fullquery>



<fullquery name="tasks_select">
<querytext>
      
select ttracker_option__option_name(:package_id, 'severity', tt.severity) 
         as pretty_severity,
       ttracker_option__option_name(:package_id, 'priority', tt.priority) 
         as pretty_priority,
       tt.ticket_id,
       tt.subject,
       to_char(tt.creation_date, 'MM/DD/YYYY HH24:MI') as created,
       c.state,
       tt.creation_user as creator_id,
       acs_object__name(tt.creation_user) as creator_name
  from wf_cases c,
       ttracker_tickets tt
  where tt.category_id = :category_id and 
        c.object_id = tt.ticket_id
        [ad_dimensional_sql $dimensional]
  [ad_order_by_from_sort_spec $orderby $table_def]

</querytext>
</fullquery>
 


<partialquery name="last_1_day">
<querytext>

tt.creation_date + '1 days'::interval > now()

</querytext>
</partialquery>



<partialquery name="last_7_days">
<querytext>

tt.creation_date + '7 days'::interval > now()

</querytext>
</partialquery>



<partialquery name="last_30_days">
<querytext>

tt.creation_date + '30 days'::interval > now()

</querytext>
</partialquery>

 
</queryset>
