# /packages/ticket-tracker/www/selection-bar.tcl

ad_page_contract {
    Display a selection bar used for viewing tickets

    @author Tony Tseng (tony@arsdigita.com)
    @author Phong Nguyen (phong@arsdigita.com)
    @creation-date 2000-11-20
    @cvs-id $Id: selection-bar.tcl,v 1.1 2001/04/20 20:51:25 donb Exp $
} {
} -properties {
    option:multirow
    status:multirow
    time:multirow
}
 
set package_id [ad_conn package_id]

set options_list [db_list_of_lists options_select {
    select name, 
           function,
           value
      from ttracker_options
     where package_id = :package_id
     order by function,value
}]

template::multirow create option name function value
foreach o $options_list {
    template::multirow append option "[lindex $o 0]" "[lindex $o 1 ]" "[lindex $o 2]"
}
template::multirow append option "all" "severity" "any"
template::multirow append option "all" "priority" "any"


set status_list [list "active" "suspended" "canceled" "finished" "all"]
template::multirow create status name value
foreach s $status_list {
    if [string equal $s "all"] {
        template::multirow append status $s "any"
    } else {
        template::multirow append status $s $s
    }            
}


set time_list [list [list "last 24hrs" "1d"] [list "last week" "1w"] \
        [list "last month" "1m"] [list "all" "any"]]
template::multirow create time name value
foreach t $time_list {
    template::multirow append time [lindex $t 0] [lindex $t 1]
}

ad_return_template
