# /packages/ticket-tracker/www/state-change.tcl

ad_page_contract {
    Change a ticket's state

    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-11-20
    @cvs-id $Id: state-change.tcl,v 1.1 2001/04/20 20:51:25 donb Exp $
} {
    ticket_id:integer,ttracker_ticket_id
    action:notnull
}

# only admin can change the state of a case
ad_require_permission $ticket_id admin

# get the state and case_id
db_1row case_id_select {
    select case_id, state
      from wf_cases
     where object_id = :ticket_id
}

switch $action {
    suspend {
        if [string equal $state "active"] {
            wf_case_suspend $case_id
        }
    }
    resume {
        if { [string equal $state "suspended"] || [string equal $state "canceled"] } {
            wf_case_resume $case_id
        }
    }
    cancel {
        if { [string equal $state "suspended"] || [string equal $state "active"] } {
            wf_case_cancel $case_id
        }
    }
}

ad_returnredirect "ticket-view?[export_url_vars ticket_id]"

