# /packages/ticket-tracker/www/ticket-add-2.tcl

ad_page_contract {
    Add a new ticket

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng   (tony@arsdigita.com)
    @creation-date 2000-11-22
    @cvs-id $Id: ticket-add-2.tcl,v 1.3 2005/03/01 00:01:16 jeffd Exp $
} {
    priority:integer
    severity:integer
    category_id:integer
    subject:nohtml,notnull
    description:html,notnull
    mime_type:notnull
}

set user_id [auth::require_login]
set package_id [ad_conn package_id]
set creation_ip [ad_conn peeraddr]

db_exec_plsql insert_ticket {
    declare
        v_ticket_id  acs_objects.object_id%TYPE;
    begin
        v_ticket_id := ttracker_ticket.new (
            context_id    => :package_id,                      
            subject       => :subject,
            description   => :description,
            mime_type     => :mime_type,
            category_id   => :category_id,
            severity      => :severity,
            priority      => :priority,
            creation_user => :user_id,
            creation_ip   => :creation_ip
        );

        acs_permission.grant_permission(
            object_id  => v_ticket_id,
            grantee_id => :user_id,
            privilege  => 'write'
        );        
    end;
}

ad_returnredirect ""

