# /packages/ticket-tracker/www/ticket-add.tcl

ad_page_contract {
    Present a form to add a ticket

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng   (tony@arsdigita.com)
    @creation-date 2000-11-22
    @cvs-id $Id: ticket-add.tcl,v 1.3 2005/03/01 00:01:16 jeffd Exp $
} { 
} -properties {
    page_title:onevalue
    context:onevalue
    target:onevalue
    submit:onevalue
    category_name:onevalue
    ticket:onerow
    categories:multirow
    option:multirow
}

# check if user is logged in
auth::require_login

# get the package_id
set package_id [ad_conn package_id]

# retrieve all categories within the package
db_multirow categories get_categories {
  select category_id, name
    from ttracker_categories
   where package_id = :package_id
   order by upper(name) 
}

set page_title "Add a ticket"
set context {"Add ticket"}
set target "ticket-add-2"
set submit "Create"
set category_name [ad_parameter CategoryName "ticket-tracker" "Category"]

set ticket(id) ""
set ticket(priority) ""
set ticket(severity) ""
set ticket(category_id) ""
set ticket(subject) ""
set ticket(description) ""
set ticket(mime_type) ""

db_multirow option get_options {
    select name, 
           value,
           function
      from ttracker_options
     where package_id = :package_id
}

ad_return_template "ticket-ae"

