# /packages/ticket-tracker/www/ticket-edit-2.tcl

ad_page_contract {
    Edit an existing ticket

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng   (tony@arsdigita.com)
    @creation-date 2000-11-28
    @cvs-id $Id: ticket-edit-2.tcl,v 1.2 2002/09/18 13:04:24 jeffd Exp $
} {
    ticket_id:integer,ttracker_ticket_id
    task_id:integer,optional
    priority:integer
    severity:integer
    category_id:integer
    subject:nohtml,notnull
    description:html,notnull
    mime_type:notnull
}

# Make sure user has write privilege on this ticket
ad_require_permission $ticket_id write

db_transaction {
    db_dml update_ttracker_tickets {
        update ttracker_tickets 
           set category_id = :category_id,
               subject = :subject,
               severity = :severity,
               priority = :priority
         where ticket_id = :ticket_id
    }
    
    # update mime_type, subject, and description 
    db_exec_plsql update_mime_subj_desc {
        begin
            ttracker_ticket.update_mime_subj_desc (
                ticket_id => :ticket_id,
                mime_type => :mime_type,
	        subject => :subject,
                description => :description
            );
        end;
    } 
} on_error {
    ns_log Error $errmsg
    ad_return_complaint 0 "There was an error updating the ticket information.<p>
                           Here is the full error message:<pre>$errmsg</pre>"
    ad_script_abort
}     
        
if {[exists_and_not_null task_id]} {
    ad_returnredirect "task?[export_url_vars task_id]"
} else {
    ad_returnredirect "ticket-view?[export_url_vars ticket_id]"
}

