# /packages/ticket-tracker/www/ticket-edit.tcl

ad_page_contract {
    Present a form to edit an existing ticket

    @author Phong Nguyen (phong@arsdigita.com)
    @author Tony Tseng (tony@arsdigita.com)
    @creation-date 2000-11-29
    @cvs-id $Id: ticket-edit.tcl,v 1.2 2002/09/06 06:57:03 jeffd Exp $
} {
    ticket_id:integer,ttracker_ticket_id
    task_id:integer,optional
} -properties {
    page_title:onevalue
    context:onevalue
    task_id:onevalue
    target:onevalue
    submit:onevalue
    category_name:onevalue
    ticket:onerow
    categories:multirow
    option:multirow
}

# Make sure user has write privilege on this ticket
ad_require_permission $ticket_id write

set context {"Edit a ticket"}
set package_id [ad_conn package_id]

set page_title "Edit a ticket"
set target "ticket-edit-2"
set submit "Edit"
set category_name [ad_parameter CategoryName "ticket-tracker" "Category"]

# get categories within this ticket tracker
db_multirow categories get_categories {
  select category_id, name
    from ttracker_categories
   where package_id = :package_id
}

# get the ticket info
db_1row ticket_info_select {
    select tt.ticket_id as id,
           tt.subject,
           tt.priority,
           tt.severity,
           tt.category_id,
           cr.mime_type,
           cr.content as description
      from ttracker_tickets tt,
           cr_revisions cr
     where tt.ticket_id = :ticket_id 
       and cr.revision_id = content_item.get_live_revision(:ticket_id)
} -column_array {ticket}

db_multirow option get_options {
    select name, 
           value,
           function
      from ttracker_options
     where package_id = :package_id
}
    
ad_return_template "ticket-ae"