ad_page_contract {
    This page toggles a given package's WAP enabled status.

    @author Shan Shan Huang (shuang@arsdigita.com)

    @creation-date November 29, 2000
    @cvs-id $Id: toggle-wap-enabled.tcl,v 1.2 2002/09/18 13:05:15 jeffd Exp $
} {
    package_id:integer
}

ns_log notice "entering toggle"

set current_stat [ad_parameter -package_id $package_id WAPEnabledP]

if { [empty_string_p $current_stat] } {
    # we need to add this parameter for this particular package
    db_1row "getVersionId" "select v.version_id, p.package_key from 
    apm_package_versions v, apm_packages p
    where p.package_id = $package_id
    and p.package_key = v.package_key
    and v.enabled_p = 't' "
    
    set parameter_id [db_string "getParameterId" "select acs_object_id_seq.nextval as parameter_id from dual"]

    db_transaction {
	apm_parameter_register -parameter_id $parameter_id "WAPEnabledP" "Is this package accessible via WAP devices" $package_key 0 "number" "" 1 1

	apm_generate_package_spec $version_id
    } on_error {
	ad_return_error "Database Error" "Could not create WAPEnabledP parameter for package $package_key, version $version_id."
        ad_script_abort
    }

    set current_stat 0
}

if { $current_stat } {
    set new_stat 0
} else {
    set new_stat 1
}

ad_parameter -set $new_stat -package_id $package_id WAPEnabledP

ad_returnredirect "/wap/admin?[export_url_vars supertype]"