ad_page_contract {
  This is the index page for WAP.  This page displays the currently recoganizable WAP user agents.

  @author Shan Shan Huang (shuang@arsdigita.com)
  
  @creation-date December 7, 2000
  @cvs-id $Id: index.tcl,v 1.1 2001/04/20 20:51:23 donb Exp $
} {
    { orderby ""}
}

set non_wap_content "
[ad_header "WAP Home"]
<h2>WAP Home</h2>
[ad_context_bar_ws_or_index "WAP Home"]
<hr>"

set wap_title "WAP Home"

set dimensional_list {
    {
	supertype "User Agent Status" active {
	    { active "Active" { where "wap.active_p = 't'" } }
	    { inactive "Inactive" { where "wap.active_p = 'f'" } }
	}
    }
}

append non_wap_content "
<table><tr><td>[ad_dimensional $dimensional_list]</td></tr></table>"

set table_def {
    { name "User Agent Name"}
    { creation_user_name "Created By"}
    { creation_date "Created On" }
    { creation_comment "Comment" }
    { last_modified "Last Modified On" }
    { modifying_user_name "Modified By" }
}

set sql_query "select decode(wap.active_p, 't', 'Active', 'Inactive') as active_status, 
wap.name, wap.creation_comment, 
to_char(o.creation_date, 'mm/dd/yyyy') as creation_date, 
to_char(o.last_modified, 'mm/dd/yyyy') as last_modified,
nvl((select cc.first_names || ' ' || cc.last_name from cc_users cc where cc.object_id = o.creation_user), 'System') as creation_user_name, 
nvl((select cc.first_names || ' ' || cc.last_name from cc_users cc where cc.object_id = o.modifying_user), 'System') as modifying_user_name
from wap_user_agents wap, acs_objects o 
where wap.user_agent_id = o.object_id 
"

if { ![wap_user_agent_p] } {
    append sql_query " [ad_dimensional_sql $dimensional_list where] 
    [ad_order_by_from_sort_spec $orderby $table_def]"
} else {
    multirow create ua_data name

    # we need to limit number of rows returned because max bytes for WAP card deck
    # is 1464 bytes.
    set counter 0
    append sql_query " and active_p = 't' "
    db_foreach "getUAdata" $sql_query {
	if { $counter < 25 } {
	    multirow append ua_data $name
	}
	incr counter
    }
}

append non_wap_content "
[ad_table -Torderby $orderby "UserAgentQuery" $sql_query $table_def] "

set footer "[ad_footer]"

